-- AddOn by Dezyne, Argent Dawn, Europe. Please give me credit when you want to redistribute or modify this addon! Contact: coenvdwel@planet.nl
-- Coen van der Wel, Eindhoven, the Netherlands.

																							local rewatch_versioni = "5.1"; -- current revision
--// FUNCTIONS //----------------------------------------------------------------------------------------------------------------------------------------------------------------

-- display a message to the user in the chat pane
-- msg: the message to pass onto the user
-- return: void
function rewatch_Message(msg)
	-- send the message to the chat pane, in yellow-ish
	DEFAULT_CHAT_FRAME:AddMessage(rewatch_loc["prefix"]..msg, 0.95, 0.85, 0.15);
	
	-- return
	return;
end;

-- displays a message to the user in the raidwarning frame
-- msg: the message to pass onto the user
-- return: void
function rewatch_RaidMessage(msg)
	-- send the message to the raid warning frame, in yellow-ish, too
	RaidNotice_AddMessage(RaidWarningFrame, msg, {r = 0.95, g = 0.85, b = 0.15});
	
	-- return
	return;
end;

-- set the ability data
-- return: void
function rewatch_SetAbs()
	rewatch_abs = {
		[rewatch_loc["lifebloom"]] = {
			Duration = 7;
			Offset = 0;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-0 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["rejuvenation"]] = {
			Duration = 12;
			Offset = 0;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-1 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["regrowth"]] = {
			Duration = 21;
			Offset = 0;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-2 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["wildgrowth"]] = {
			Duration = 7;
			Offset = 0;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-3 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["swiftmend"]] = {
			Duration = 15;
			Offset = rewatch_loadInt["SmallButtonMargin"];
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["abolishpoison"]] = {
			Duration = 1.5;
			Offset = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*1;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["removecurse"]] = {
			Duration = 1.5;
			Offset = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*2;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["healingtouch"]] = {
			Duration = 1.5;
			Offset = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*3;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
		[rewatch_loc["nourish"]] = {
			Duration = 1.5;
			Offset = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*4;
			Offset_Y = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
		};
	};
	-- last spell of reju lasts 3 seconds longer, take that into account
	if(string.sub(select(2, GetSpellInfo(rewatch_loc["rejuvenation"])), -2) == "15") then
		rewatch_abs[rewatch_loc["rejuvenation"]].Duration = 15;
	end;
end;

-- update all the offsets in the abilities table
-- return: void
function rewatch_UpdateOffset()
	rewatch_abs[rewatch_loc["lifebloom"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-0 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["rejuvenation"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-1 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["wildgrowth"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-3 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["regrowth"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-2 -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["swiftmend"]]["Offset"] = rewatch_loadInt["SmallButtonMargin"];
	rewatch_abs[rewatch_loc["swiftmend"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["abolishpoison"]]["Offset"] = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*1;
	rewatch_abs[rewatch_loc["abolishpoison"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["removecurse"]]["Offset"] = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*2;
	rewatch_abs[rewatch_loc["removecurse"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["healingtouch"]]["Offset"] = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*3;
	rewatch_abs[rewatch_loc["healingtouch"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_abs[rewatch_loc["nourish"]]["Offset"] = (rewatch_loadInt["SmallButtonMargin"]+rewatch_loadInt["SmallButtonWidth"])*4;
	rewatch_abs[rewatch_loc["nourish"]]["Offset_Y"] = (rewatch_loadInt["SpellBarHeight"] + rewatch_loadInt["SpellBarMargin"])*-(3+rewatch_loadInt["WildGrowth"]) -(rewatch_loadInt["HealthBarHeight"]+rewatch_loadInt["SpellBarMargin"]);
	rewatch_loadInt["FrameWidth"] = rewatch_loadInt["SpellBarWidth"]+rewatch_loadInt["SideBar"];
	rewatch_loadInt["FrameHeight"] = (rewatch_loadInt["SpellBarMargin"] + rewatch_loadInt["SpellBarHeight"])*(3+rewatch_loadInt["WildGrowth"]) + rewatch_loadInt["SmallButtonHeight"] + rewatch_loadInt["SpellBarMargin"]*2 + rewatch_loadInt["HealthBarHeight"];
end;

-- pops up the tooltip bar
-- data: the data to put in the tooltip. either a spell name or player name.
-- return: void
function rewatch_SetTooltip(data)
	-- empty tooltip
	rewatch_tooltip:ClearLines();
	-- is it a spell?
	local md = rewatch_GetSpellId(data);
	if(md < 0) then
		-- if not, then is it a player?
		md = rewatch_GetPlayer(data);
		if(md >= 0) then
			rewatch_tooltip:SetUnit(rewatch_bars[md]["Player"]);
			rewatch_tooltip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -25, 25);
		end; -- do nothing with the tooltip if not
	else
		rewatch_tooltip:SetSpell(md, BOOKTYPE_SPELL);
		rewatch_tooltip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -25, 25);
	end;
	
	-- return
	return;
end;

-- gets the spell ID of the highest rank of the specified spell
-- spellName: the name of the spell to get the highest ranked spellId from
-- return: the corresponding spellId
function rewatch_GetSpellId(spellName)
	-- get spell info and highest rank, return if the user can't cast it (not learned, etc)
	local name, rank, icon = GetSpellInfo(spellName);
	if(name == nil) then return -1; end;
	-- loop through all book spells, return the number if it matches above data
	local i, ispell, irank = 1, GetSpellName(1, BOOKTYPE_SPELL);
	repeat
		if ((ispell == name) and ((rank == irank) or (not irank))) then return i; end;
		i, ispell, irank = i+1, GetSpellName(i+1, BOOKTYPE_SPELL);
	until (not ispell);
	
	-- return default -1
	return -1;
end;

-- clears the entire list and resets it
-- return: void
function rewatch_Clear()
	-- call each playerframe's Hide method
	for i=1,rewatch_i-1 do local val = rewatch_bars[i]; if(val) then rewatch_HidePlayer(i); end; end;
	rewatch_bars = nil; rewatch_bars = {}; rewatch_i = 1;
	
	-- return
	return;
end;

-- get the number of the supplied player's place in the player table, or -1
-- player: name of the player to search for
-- return: the supplied player's table index, or -1 if not found
function rewatch_GetPlayer(player)
	-- for every seen player; return if the name matches the supplied name
	local guid = UnitGUID(player);
	-- ignore pet guid; this changes sometimes
	if(not UnitIsPlayer(player)) then guid = false; end;
	-- browse list and return corresponding id
	for i=1,rewatch_i-1 do local val = rewatch_bars[i]; if(val) then
		if(not guid) then
			if(val["Player"] == player) then return i; end;
		elseif(val["UnitGUID"] == guid) then return i;
		-- load bug, UnitGUID returns nil when not fully loaded, even on "player"
		elseif((player == UnitName("player")) and (not val["UnitGUID"])) then val["UnitGUID"] = guid; return i; end;
	end; end;
	
	-- return -1 if not found
	return -1;
end;

-- checks if the player or pet is in the group
-- player: name of the player or pet to check for
-- return: true, if the player is the user, or in the user's party or raid (or pet); false elsewise
function rewatch_InGroup(player)
	-- catch a self-check; return true if searching for the user itself
	if(UnitName("player") == player) then return true;
	-- process by environment (party or raid)
	elseif(GetNumRaidMembers() > 0) then if(UnitPlayerOrPetInRaid(player)) then return true; end;
	elseif(GetNumPartyMembers() > 0) then if(UnitPlayerOrPetInParty(player)) then return true; end;
	end;
	
	-- return
	return false;
end;

-- performs a poison check on given unit, will return true if a poison debuff was found
-- playerId: the index number of the player in the player table
-- return: true if the player with the supplied id has a poison, false if not
function rewatch_IsPoisoned(playerId)
	return (rewatch_bars[playerId]["Poison"] ~= nil);
end;

-- performs a curse check on given unit, will return true if a curse debuff was found
-- playerId: the index number of the player in the player table
-- return: true if the player with the supplied id has a curse, false if not
function rewatch_IsCursed(playerId)
	return (rewatch_bars[playerId]["Curse"] ~= nil);
end;

-- checks the druid buffs on players in your list
-- return: void
function rewatch_BuffCheck()
	-- check all listed players
	local thorns, motw = false, {};
	for i,val in ipairs(rewatch_bars) do if(val) then
		local thisMotw = false;
		for j=1,40 do
			local name = UnitBuff(val["Player"], j, 0);
			if(thorns and thisMotw) then break; elseif(name == rewatch_loc["thorns"]) then thorns = true;
			elseif((name == rewatch_loc["markofthewild"]) or (name == rewatch_loc["giftofthewild"])) then thisMotw = true; end;
		end;
		if(not thisMotw) then table.insert(motw, val["Player"]); end;
	end; end;
	-- build report
	local msg = rewatch_loc["buffresults"].." ";
	if(not thorns) then msg = msg..rewatch_loc["nothorns"].." "; end;
	if(table.getn(motw) > 0) then
		msg = msg..rewatch_loc["missingmotw"].." "..motw[1];
		for i=2,table.getn(motw) do	msg = msg..", "..motw[i]; end;
	end;
	if((thorns) and (table.getn(motw) == 0)) then msg = msg.."Ok."; end;
	-- message the user
	rewatch_Message(msg);
	
	-- return
	return;
end;

-- loads the internal vars from the savedvariables
-- return: void
function rewatch_OnLoad()
	-- reset changed var (options window)
	rewatch_ChangedDimentions = false;
	-- has been loaded before, get vars
	if(rewatch_load) then
		-- if the savedvariable data isn't corrupt
		if(	(rewatch_load["GcdAlpha"]) and (rewatch_load["HideSolo"]) and (rewatch_load["Hide"]) and
			(rewatch_load["AutoGroup"]) and (rewatch_load["NaturesSplendor"]) and (rewatch_load["GoSM"]) and
			(rewatch_load["GoLB"]) and (rewatch_load["T5"]) and (rewatch_load["FrameColor"]) and
			(rewatch_load["SpellBarWidth"]) and (rewatch_load["SpellBarHeight"]) and
			(rewatch_load["SpellBarMargin"]) and (rewatch_load["NumFramesWide"]) and (rewatch_load["SmallButtonWidth"]) and
			(rewatch_load["SmallButtonHeight"]) and (rewatch_load["SmallButtonMargin"])
		) then
			-- if the user is using a version before 5.0, enforce default dimentions
			local update = (rewatch_version == nil);
			if(update) then
				rewatch_load["SpellBarWidth"] = 90;
				rewatch_load["SpellBarHeight"] = 9;
				rewatch_load["SmallButtonWidth"] = 18;
				rewatch_load["SmallButtonHeight"] = 18;
				rewatch_load["SmallButtonMargin"] = 0;
				rewatch_load["WildGrowth"] = 1;
				rewatch_load["ClassColors"] = {
					DEATHKNIGHT = {r=0.77;g=0.12;b=0.23};
					DRUID = {r=1.00;g=0.49;b=0.04};
					HUNTER = {r=0.67;g=0.83;b=0.45};
					MAGE = {r=0.41;g=0.80;b=0.94};
					PALADIN = {r=0.96;g=0.55;b=0.73};
					PRIEST = {r=1.00;g=1.00;b=1.00};
					ROGUE = {r=1.00;g=0.96;b=0.41};
					SHAMAN = {r=0.14;g=0.35;b=1.00};
					WARLOCK = {r=0.58;g=0.51;b=0.79};
					WARRIOR = {r=0.78;g=0.61;b=0.43}
				}
				rewatch_load["Font"] = "GameFontHighlightSmall";
				rewatch_load["BarColor"..rewatch_loc["lifebloom"]] = { r=0; g=0; b=0.8};
				rewatch_load["BarColor"..rewatch_loc["rejuvenation"]] = { r=0.85; g=0.15; b=0.80};
				rewatch_load["BarColor"..rewatch_loc["regrowth"]] = { r=0.05; g=0.3; b=0.1};
				rewatch_load["BarColor"..rewatch_loc["wildgrowth"]] = { r=0.5; g=0.8; b=0.3};
			end;
			-- update changes from 5.0 to 5.0.1
			update = update or (rewatch_version == "5.0");
			if(update) then
				rewatch_load["HealthBarHeight"] = 18;
				rewatch_load["SpellBarHeight"] = 9;
				rewatch_load["BarColor"..rewatch_loc["lifebloom"]] = { r=0.6; g=0; b=0};
				rewatch_load["BarColor"..rewatch_loc["lifebloom"].."2"] = { r=1; g=0.5; b=0};
				rewatch_load["BarColor"..rewatch_loc["lifebloom"].."3"] = { r=0; g=0; b=0.8};
				rewatch_load["Labels"] = 0;
			end;
			-- update changes from 5.0.1/5.0.2 to 5.0.3
			update = update or (rewatch_version == "5.0.1") or (rewatch_version == "5.0.2");
			if(update) then
				rewatch_load["SideBar"] = 7;
			end;
			-- set internal vars from loaded vars
			rewatch_loadInt["Loaded"] = true;
			rewatch_loadInt["GcdAlpha"] = rewatch_load["GcdAlpha"];
			rewatch_loadInt["HideSolo"] = rewatch_load["HideSolo"];
			rewatch_loadInt["Hide"] = rewatch_load["Hide"];
			rewatch_loadInt["AutoGroup"] = rewatch_load["AutoGroup"];
			rewatch_loadInt["NaturesSplendor"] = rewatch_load["NaturesSplendor"];
			rewatch_loadInt["WildGrowth"] = rewatch_load["WildGrowth"];
			rewatch_loadInt["GoLB"] = rewatch_load["GoLB"];
			rewatch_loadInt["GoSM"] = rewatch_load["GoSM"];
			rewatch_loadInt["FrameColor"] = rewatch_load["FrameColor"];
			rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]] = rewatch_load["BarColor"..rewatch_loc["lifebloom"]];
			rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"] = rewatch_load["BarColor"..rewatch_loc["lifebloom"].."2"];
			rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"] = rewatch_load["BarColor"..rewatch_loc["lifebloom"].."3"];
			rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]] = rewatch_load["BarColor"..rewatch_loc["rejuvenation"]];
			rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]] = rewatch_load["BarColor"..rewatch_loc["regrowth"]];
			rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]] = rewatch_load["BarColor"..rewatch_loc["wildgrowth"]];
			rewatch_loadInt["T5"] = rewatch_load["T5"];
			rewatch_loadInt["Labels"] = rewatch_load["Labels"];
			rewatch_loadInt["Font"] = rewatch_load["Font"];
			rewatch_loadInt["SideBar"] = rewatch_load["SideBar"];
			rewatch_loadInt["ClassColors"] = rewatch_load["ClassColors"];
			rewatch_loadInt["SpellBarWidth"] = rewatch_load["SpellBarWidth"];
			rewatch_loadInt["SpellBarHeight"] = rewatch_load["SpellBarHeight"];
			rewatch_loadInt["HealthBarHeight"] = rewatch_load["HealthBarHeight"];
			rewatch_loadInt["SpellBarMargin"] = rewatch_load["SpellBarMargin"];
			rewatch_loadInt["NumFramesWide"] = rewatch_load["NumFramesWide"];
			rewatch_loadInt["SmallButtonWidth"] = rewatch_load["SmallButtonWidth"];
			rewatch_loadInt["SmallButtonHeight"] = rewatch_load["SmallButtonHeight"];
			rewatch_loadInt["SmallButtonMargin"] = rewatch_load["SmallButtonMargin"];
			-- apply possible changes
			rewatch_loadInt["FrameWidth"] = rewatch_loadInt["SpellBarWidth"]+rewatch_loadInt["SideBar"];
			rewatch_loadInt["FrameHeight"] = (rewatch_loadInt["SpellBarMargin"] + rewatch_loadInt["SpellBarHeight"])*(3+rewatch_loadInt["WildGrowth"]) + rewatch_loadInt["SmallButtonHeight"] + rewatch_loadInt["SpellBarMargin"]*2 + rewatch_loadInt["HealthBarHeight"];
			for _, cd in ipairs(rewatch_gcds) do cd:SetAlpha(rewatch_loadInt["GcdAlpha"]); end;
			for i=1,rewatch_i-1 do local val = rewatch_bars[i]; if(val) then val["Frame"]:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a); end; end;
			if(((rewatch_i == 2) and (rewatch_loadInt["HideSolo"] == 1)) or (rewatch_loadInt["Hide"] == 1)) then rewatch_f[1]:Hide(); else rewatch_ShowFrame(); end;
			rewatch_SetAbs(); rewatch_OptionsFromData(true); rewatch_UpdateSwatch();
			-- set current version
			rewatch_version = rewatch_versioni;
		-- or if it's modified/outdated, reset it
		else rewatch_load = nil; rewatch_version = nil; end;
	-- not loaded before, initialise and welcome new user
	else
		rewatch_load = {};
		rewatch_load["GcdAlpha"], rewatch_load["HideSolo"], rewatch_load["Hide"], rewatch_load["AutoGroup"], rewatch_load["NaturesSplendor"], rewatch_load["GoLB"], rewatch_load["GoSM"], rewatch_load["T5"] = 1, 0, 0, 1, 0, 0, 0, 0;
		rewatch_load["FrameColor"] = { r=0; g=0; b=0; a=0.3 };
		rewatch_load["BarColor"..rewatch_loc["lifebloom"]] = { r=0.6; g=0; b=0};
		rewatch_load["BarColor"..rewatch_loc["lifebloom"].."2"] = { r=1; g=0.5; b=0};
		rewatch_load["BarColor"..rewatch_loc["lifebloom"].."3"] = { r=0; g=0; b=0.8};
		rewatch_load["BarColor"..rewatch_loc["rejuvenation"]] = { r=0.85; g=0.15; b=0.80};
		rewatch_load["BarColor"..rewatch_loc["regrowth"]] = { r=0.05; g=0.3; b=0.1};
		rewatch_load["BarColor"..rewatch_loc["wildgrowth"]] = { r=0.5; g=0.8; b=0.3};
		rewatch_load["Labels"] = 0; rewatch_load["SideBar"] = 7;
		rewatch_load["SpellBarWidth"] = 90; rewatch_load["SpellBarHeight"] = 9;
		rewatch_load["HealthBarHeight"] = 18; rewatch_load["SpellBarMargin"] = 0;
		rewatch_load["NumFramesWide"] = 5; rewatch_load["SmallButtonWidth"] = 18;
		rewatch_load["SmallButtonHeight"] = 18; rewatch_load["SmallButtonMargin"] = 0;
		rewatch_load["WildGrowth"] = 1; rewatch_load["Font"] = "GameFontHighlightSmall";
		rewatch_load["ClassColors"] = {
			DEATHKNIGHT = {r=0.77;g=0.12;b=0.23};
			DRUID = {r=1.00;g=0.49;b=0.04};
			HUNTER = {r=0.67;g=0.83;b=0.45};
			MAGE = {r=0.41;g=0.80;b=0.94};
			PALADIN = {r=0.96;g=0.55;b=0.73};
			PRIEST = {r=1.00;g=1.00;b=1.00};
			ROGUE = {r=1.00;g=0.96;b=0.41};
			SHAMAN = {r=0.14;g=0.35;b=1.00};
			WARLOCK = {r=0.58;g=0.51;b=0.79};
			WARRIOR = {r=0.78;g=0.61;b=0.43}
		}
		rewatch_Message(rewatch_loc["welcome"]); rewatch_RaidMessage(rewatch_loc["welcome"]);
		-- set current version
		rewatch_version = rewatch_versioni;
	end;
end;


-- trigger the cooldown overlays
-- return: void
function rewatch_TriggerCooldown()
	-- get global cooldown, and trigger it on all frames
	local start, duration, enabled = GetSpellCooldown(rewatch_loc["rejuvenation"]); -- some non-cd spell
	for _, cd in ipairs(rewatch_gcds) do
		CooldownFrame_SetTimer(cd, start, duration, enabled);
	end;
	
	-- return
	return;
end;

-- show the first rewatch frame, with the last 'flash' of the cooldown effect
-- return: void
function rewatch_ShowFrame()
	rewatch_f[1]:Show();
	for _, cd in ipairs(rewatch_gcds) do
		CooldownFrame_SetTimer(cd, GetTime()-1, 1.125, 1);
	end;
end;

-- adjusts the parent frame container's height
-- parentFrame: the frame to adjust
-- return: void
function rewatch_AlterFrame(parentFrame)
	-- get the index of the frame
	local i = 1; if(parentFrame) then
		for j, frame in ipairs(rewatch_f) do
			if(frame == parentFrame) then i = j; break; end;
		end;
	end;
	-- set height and width according to number of frames
	local num = rewatch_f[i]:GetNumChildren()-1;
	local width = math.min(rewatch_loadInt["NumFramesWide"],  math.max(num, 1)) * rewatch_loadInt["FrameWidth"];
	local height = math.ceil(num/rewatch_loadInt["NumFramesWide"]) * rewatch_loadInt["FrameHeight"];
	rewatch_f[i]:SetWidth(width+1); rewatch_f[i]:SetHeight(height+15);
	rewatch_gcds[i]:SetWidth(rewatch_f[i]:GetWidth()); rewatch_gcds[i]:SetHeight(rewatch_f[i]:GetHeight());
	-- hide/show on solo
	if(((num == 1) and (rewatch_loadInt["HideSolo"] == 1)) or (rewatch_loadInt["Hide"] == 1)) then rewatch_f[i]:Hide(); else rewatch_f[i]:Show(); end;
	-- make sure frames have a solid height and width (bugfix)
	for j=1,rewatch_i-1 do local val = rewatch_bars[j]; if(val) then
		if(not((val["Frame"]:GetWidth() == rewatch_loadInt["FrameWidth"]) and (val["Frame"]:GetHeight() == rewatch_loadInt["FrameHeight"]))) then
			val["Frame"]:SetWidth(rewatch_loadInt["FrameWidth"]); val["Frame"]:SetHeight(rewatch_loadInt["FrameHeight"]);
		end;
	end; end;
	
	-- return
	return;
end;

-- snap the supplied frame to the grid when it's placed on a rewatch_f frame
-- frame: the frame to snap to a grid
-- return: void
function rewatch_SnapToGrid(frame)
	-- return if in combat
	if(InCombatLockdown() == 1) then return -1; end;
	
	-- get parent frame
	local parent = frame:GetParent();
	if(parent ~= UIParent) then
		-- get frame's location relative to it's parent's
		local dx, dy = frame:GetLeft()-parent:GetLeft(), frame:GetTop()-parent:GetTop();
		-- make it snap (make dx a number closest to frame:GetWidth*n...)
		dx = math.floor((dx/(rewatch_loadInt["FrameWidth"] + rewatch_loadInt["SpellBarMargin"]))+0.5) * (rewatch_loadInt["FrameWidth"] + rewatch_loadInt["SpellBarMargin"]);
		dy = math.floor((dy/(rewatch_loadInt["FrameHeight"] + rewatch_loadInt["SpellBarMargin"]))+0.5) * (rewatch_loadInt["FrameHeight"] + rewatch_loadInt["SpellBarMargin"]);
		-- check if this is outside the frame, remove it
		if((dx < 0) or (dy > 0) or (dx+5 >= parent:GetWidth()) or ((dy*-1)+5 >= parent:GetHeight())) then
			-- remove it from it's parent
			frame:SetParent(UIParent); rewatch_AlterFrame(parent);
			rewatch_Message(rewatch_loc["offFrame"]);
		-- if it's in the frame, move it
		else
			-- apply the location
			frame:ClearAllPoints();
			frame:SetPoint("TOPLEFT", parent, "TOPLEFT", dx, dy);
			frame:SetPoint("BOTTOMRIGHT", parent, "TOPLEFT", dx+rewatch_loadInt["FrameWidth"], dy-rewatch_loadInt["FrameHeight"]);
		end;
	else
		-- check if there's need to snap it back onto the frame
		local dx, dy;
		for _, parent in ipairs(rewatch_f) do
			dx, dy = frame:GetLeft()-parent:GetLeft(), frame:GetTop()-parent:GetTop();
			if((dx > 0) and (dx > 0) and (dx < parent:GetWidth()) and (dy < parent:GetHeight())) then
				frame:SetParent(parent); rewatch_AlterFrame(parent);
				rewatch_SnapToGrid(frame); rewatch_Message(rewatch_loc["backOnFrame"]);
			end;
		end;
	end;
	
	-- return
	return;
end;

-- return the first available empty spot in the frame
-- frame: the outline (parent) frame in which the player frame should be positioned
-- return: position coordinates; { x, y }
function rewatch_GetFramePos(frame)
	-- assume: there is at least one free position in the specified parent frame
	local children = { frame:GetChildren() }; local x, y, found;
	-- walk through the available spots, left to right, top to bottom
	for dy=0, -7, -1 do for dx=0, 4 do
		found, x, y = false, (rewatch_loadInt["FrameWidth"] + rewatch_loadInt["SpellBarMargin"])*dx, (rewatch_loadInt["FrameHeight"] + rewatch_loadInt["SpellBarMargin"])*dy;
		-- check if there's a frame here already
		for i, child in ipairs(children) do
			if((child:GetLeft() and (i>1))) then
				if((math.abs(x - (child:GetLeft()-frame:GetLeft())) < 1) and (math.abs(y - (child:GetTop()-frame:GetTop())) < 1)) then
					found = true; break; --[[ break for children loop ]] end;
			end;
		end;
		-- if not, we found a spot and we should break!
		if(not found) then break; --[[ break for dxloop ]] end;
	end; if(not found) then break; --[[ break for dy loop ]] end; end;
	
	-- return either the found spot, or a formula based on array positioning (fallback)
	if(found) then return frame:GetWidth()*((rewatch_i-1)%rewatch_loadInt["NumFramesWide"]), math.floor((rewatch_i-1)/rewatch_loadInt["NumFramesWide"]) * -frame:GetHeight();
	else return x, y; end;
end;

-- process a swiftmend cast by the player, on specified playerId
-- playerId: the index number of the player in the player table
-- return: void
function rewatch_ProcessSwiftmend(playerId)
	-- only consume if the glyph is not present
	if(rewatch_loadInt["GoSM"] == 0) then
		-- assume it consumed a rejuvenation
		local consumed = rewatch_loc["rejuvenation"];
		-- check if this assumption was wrong, and if so, alter it
		if((rewatch_bars[playerId][consumed] == 0) or (((rewatch_bars[playerId][rewatch_loc["regrowth"]] > 0)) and (rewatch_bars[playerId][rewatch_loc["regrowth"]] < rewatch_bars[playerId][consumed]))) then
			consumed = rewatch_loc["regrowth"];
		end;
		-- clear the bar that was consumed and unset it's end time
		rewatch_bars[playerId][consumed] = 0; rewatch_bars[playerId][consumed.."Bar"]:SetValue(0);
		if(rewatch_loadInt["Labels"] == 0) then
			rewatch_bars[playerId][consumed.."Bar"].text:SetText("");
		end;
	end;
	-- trigger all cooldown overlays of every player's swiftmend button
	local start, duration, enabled = GetSpellCooldown(rewatch_loc["swiftmend"]);
	if(duration < 2) then -- sometimes doesn't trigger? now it does! HARHAR!
		start, duration = GetTime(), 15;
	end;
	for i=1,rewatch_i-1 do local val = rewatch_bars[i]; if(val) then
		CooldownFrame_SetTimer(val["SwiftmendButton"].cooldown, start, duration, enabled);
	end; end;
	
	-- return
	return;
end;

-- compares the current player table to the party/raid schedule
-- return: void
function rewatch_ProcessGroup()
	local name, i, n, m;
	-- remove non-grouped players
	for i=1,rewatch_i-1 do if(rewatch_bars[i]) then
		if(not rewatch_InGroup(rewatch_bars[i]["Player"])) then rewatch_HidePlayer(i); end;
	end; end;
	-- process raid group
	n = GetNumRaidMembers(); if(n > 0) then
		-- for each group, for each group member, if he's not in the list, add him
		for m=1, 8 do for i=1, n do
			name, _, subgroup = GetRaidRosterInfo(i) if((name) and (rewatch_GetPlayer(name) == -1) and (subgroup == m)) then rewatch_AddPlayer(name); end;
		end; end;
	-- or, process party group
	elseif(GetNumPartyMembers() > 0) then 
		n = GetNumPartyMembers();
		-- for each group member, if he's not in the list, add him
		for i=1, n do name = UnitName("party"..i); if(rewatch_GetPlayer(name) == -1) then rewatch_AddPlayer(name); end; end;
	-- or if none, remove all but yourself
	else rewatch_i = 2; end;
	
	-- return
	return;
end;

-- create a spell button with icon and add it to the global player table
-- spellName: the name of the spell to create a bar for (must be in rewatch_abs and have Offset)
-- playerId: the index number of the player in the player table
-- btnIcon: the string path and name with extention of the icon to use
-- return: the created spell button reference
function rewatch_CreateButton(spellName, playerId, btnIcon)
	local nrs = CreateFrame("BUTTON", nil, rewatch_bars[playerId]["Frame"], "SecureActionButtonTemplate");
	nrs:SetWidth(rewatch_loadInt["SmallButtonWidth"]); nrs:SetHeight(rewatch_loadInt["SmallButtonHeight"]);
	nrs:SetPoint("TOPLEFT", rewatch_bars[playerId]["Frame"], "TOPLEFT", rewatch_abs[spellName]["Offset"], rewatch_abs[spellName]["Offset_Y"]);
	nrs:RegisterForClicks("LeftButtonDown"); nrs:SetAttribute("type1", "spell"); nrs:SetAttribute("unit", rewatch_bars[playerId]["Player"]);
	nrs:SetAttribute("spell1", spellName); nrs:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square.blp");
	nrs:SetNormalTexture(btnIcon);
	nrs:SetScript("OnEnter", function() rewatch_SetTooltip(spellName); end);
	nrs:SetScript("OnLeave", function() rewatch_tooltip:SetOwner(WorldFrame, "ANCHOR_NONE"); end);
	
	-- return
	return nrs;
end;

-- create a spell bar with text and add it to the global player table
-- spellName: the name of the spell to create a bar for (must be in rewatch_abs and have Offset)
-- playerId: the index number of the player in the player table
-- return: the created spell bar reference
function rewatch_CreateBar(spellName, playerId)
	-- create the bar
	local b = CreateFrame("STATUSBAR", spellName..playerId, rewatch_bars[playerId]["Frame"], "TextStatusBar"); b:SetWidth(rewatch_loadInt["SpellBarWidth"]); b:SetHeight(rewatch_loadInt["SpellBarHeight"]);
	b:SetPoint("TOPLEFT", rewatch_bars[playerId]["Frame"], "TOPLEFT", rewatch_abs[spellName]["Offset"], rewatch_abs[spellName]["Offset_Y"]);
	b:SetBackdrop({bgFile = nil, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	b:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar"); b:SetStatusBarColor(rewatch_loadInt["BarColor"..spellName].r, rewatch_loadInt["BarColor"..spellName].g, rewatch_loadInt["BarColor"..spellName].b, 0.8);
	-- take the extra time into account
	local extraTime = 0;
	-- - talented nature's splendor
	if(rewatch_loadInt["NaturesSplendor"] == 1) then extraTime = rewatch_extraTime[spellName]; end;
	-- if it's lifebloom
	if(spellName == rewatch_loc["lifebloom"]) then
		-- - glyph of lifebloom extra time?
		if(rewatch_loadInt["GoLB"] == 1) then
			extraTime = extraTime + 1;
		end;
	-- - T5 set bonus
	elseif((spellName == rewatch_loc["regrowth"]) and (rewatch_loadInt["T5"] == 1)) then
		extraTime = extraTime + 6;
	end;
	-- set bar reach
	b:SetMinMaxValues(0, rewatch_abs[spellName]["Duration"] + extraTime); b:SetValue(0);
	-- put text in bar
	b.text = b:CreateFontString("$parentText", "ARTWORK", rewatch_loadInt["Font"]);
	b.text:SetPoint("RIGHT", b); b.text:SetAllPoints();
	if(rewatch_loadInt["Labels"] == 1) then b.text:SetText(spellName); else b.text:SetText(""); end;
	-- overlay cast button
	local bc = CreateFrame("BUTTON", nil, b, "SecureActionButtonTemplate");
	bc:SetWidth(rewatch_loadInt["SpellBarWidth"]); bc:SetHeight(rewatch_loadInt["SpellBarHeight"]); bc:SetPoint("TOPLEFT", b, "TOPLEFT", 0, 0);
	bc:RegisterForClicks("LeftButtonDown"); bc:SetAttribute("type1", "spell"); bc:SetAttribute("unit", rewatch_bars[playerId]["Player"]);
	bc:SetAttribute("spell1", spellName); bc:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square.blp");
	
	-- return the reference to the spell bar
	return b;
end;

-- update a bar by resetting spell duration
-- spellName: the name of the spell to reset it's duration from
-- playerId: the index number of the player in the player table
-- return: void
function rewatch_UpdateBar(spellName, playerId)	
	-- return if playerId (returned from AddPlayer) is invalid
	if(playerId < 0) then return; end;
	
	-- if the spell exists
	if(rewatch_bars[playerId][spellName]) then
		-- refresh the end time and bar value
		local _, _, lag = GetNetStats();
		local extraTime = 0; if(rewatch_loadInt["NaturesSplendor"] == 1) then extraTime = rewatch_extraTime[spellName]; end;
		-- update lifebloom stack counter
		if(spellName == rewatch_loc["lifebloom"]) then
			rewatch_bars[playerId]["LifebloomStacks"] = math.min(rewatch_bars[playerId]["LifebloomStacks"]+1, 3);
			local s = rewatch_bars[playerId]["LifebloomStacks"]; if(s == 1) then s = ""; end;
			rewatch_bars[playerId][rewatch_loc["lifebloom"].."Bar"]:SetStatusBarColor(rewatch_loadInt["BarColor"..spellName..s].r, rewatch_loadInt["BarColor"..spellName..s].g, rewatch_loadInt["BarColor"..spellName..s].b, 0.8);
			if(rewatch_loadInt["GoLB"] == 1) then extraTime = extraTime + 1; end;
		-- take t5 set bonus into account
		elseif((spellName == rewatch_loc["regrowth"]) and (rewatch_loadInt["T5"] == 1)) then
			extraTime = extraTime + 6;
			rewatch_bars[playerId][spellName.."Bar"]:SetStatusBarColor(rewatch_loadInt["BarColor"..spellName].r, rewatch_loadInt["BarColor"..spellName].g, rewatch_loadInt["BarColor"..spellName].b, 0.8);
		else
			rewatch_bars[playerId][spellName.."Bar"]:SetStatusBarColor(rewatch_loadInt["BarColor"..spellName].r, rewatch_loadInt["BarColor"..spellName].g, rewatch_loadInt["BarColor"..spellName].b, 0.8);
		end;
		-- set bar values
		rewatch_bars[playerId][spellName] = GetTime() +  rewatch_abs[spellName]["Duration"] - lag/1000 + extraTime;
		rewatch_bars[playerId][spellName.."Bar"]:SetValue(rewatch_abs[spellName]["Duration"] + extraTime);
	end;
	
	-- return
	return;
end;

-- clear a bar back to 0 because it's been dispelled or removed
-- spellName: the name of the spell to reset it's duration from
-- playerId: the index number of the player in the player table
-- return: void
function rewatch_DowndateBar(spellName, playerId)
	-- if the spell exists
	if(rewatch_bars[playerId][spellName]) then
		local _, _, lag = GetNetStats();
		if((rewatch_bars[playerId][spellName] - GetTime()) > (1 + lag/1000)) then
			-- reset lifebloom stack counter
			if(spellName == rewatch_loc["lifebloom"]) then
				rewatch_bars[playerId]["LifebloomStacks"] = 0;
			end;
			-- reset bar values
			rewatch_bars[playerId][spellName] = 0;
			if(rewatch_loadInt["Labels"] == 0) then rewatch_bars[playerId][spellName.."Bar"].text:SetText(""); end;
			rewatch_bars[playerId][spellName.."Bar"]:SetValue(0);
		end;
	end;
	
	-- return
	return;
end;

-- add a player to the players table and create his bars and button
-- player: the name of the player
-- return: the index number the player has been assigned
function rewatch_AddPlayer(player)
	-- return if in combat
	if(InCombatLockdown() == 1) then return -1; end;
	
	-- set vars
	rewatch_bars[rewatch_i] = {};
	-- build frame
	local x, y = rewatch_GetFramePos(rewatch_f[1]);
	local frame = CreateFrame("FRAME", nil, rewatch_f[1]); frame:SetWidth(rewatch_loadInt["FrameWidth"]); frame:SetHeight(rewatch_loadInt["FrameHeight"]);
	frame:SetPoint("TOPLEFT", rewatch_f[1], "TOPLEFT", x, y); frame:EnableMouse(true); frame:SetMovable(true);
	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil, tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	frame:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a);
	frame:SetScript("OnMouseDown", function() if(not rewatch_loadInt["Lock"]) then frame:StartMoving(); rewatch_f[1]:SetBackdrop({bgFile = nil, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 10, edgeSize = 10, insets = { left = 3, right = 3, top = 3, bottom = 3 }}); end; end);
	frame:SetScript("OnMouseUp", function() frame:StopMovingOrSizing(); rewatch_SnapToGrid(frame); rewatch_f[1]:SetBackdrop({bgFile = nil, edgeFile = nil, tile = 1, tileSize = 10, edgeSize = 10, insets = { left = 3, right = 3, top = 3, bottom = 3 }}); end);
	-- create player HP bar
	local statusbar = CreateFrame("STATUSBAR", nil, frame, "TextStatusBar"); statusbar:SetWidth(rewatch_loadInt["SpellBarWidth"]); statusbar:SetHeight(rewatch_loadInt["HealthBarHeight"]-4);
	statusbar:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, -1);
	statusbar:SetBackdrop({bgFile = nil, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	statusbar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar"); statusbar:SetStatusBarColor(0.0, 0.6, 0.0, 0.8);
	statusbar:SetMinMaxValues(0, 1); statusbar:SetValue(0);
	-- class-color it / classcolor sidebar
	local _, class = UnitClass(player); if(class) then
		local ccsb = CreateFrame("FRAME", nil, frame); ccsb:SetWidth(rewatch_loadInt["SideBar"]); ccsb:SetHeight(rewatch_loadInt["FrameHeight"]-1);
		ccsb:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil, tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		ccsb:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -1); ccsb:SetBackdropColor(rewatch_loadInt["ClassColors"][class].r, rewatch_loadInt["ClassColors"][class].g, rewatch_loadInt["ClassColors"][class].b, 0.8);
		--local classText = statusbar:CreateFontString("$parentText", "ARTWORK", rewatch_loadInt["Font"]);
		--classText:SetTextColor(rewatch_loadInt["ClassColors"][class].r, rewatch_loadInt["ClassColors"][class].g, rewatch_loadInt["ClassColors"][class].b, 1);
		--classText:SetPoint("LEFT", statusbar, "LEFT"); classText:SetText(class:sub(1, 1));
	end;
	-- put text in HP bar
	statusbar.text = statusbar:CreateFontString("$parentText", "ARTWORK", rewatch_loadInt["Font"]);
	statusbar.text:SetAllPoints(); statusbar.text:SetText(player);
	-- energy/mana/rage bar
	local statusbar2 = CreateFrame("STATUSBAR", nil, frame, "TextStatusBar"); statusbar2:SetWidth(rewatch_loadInt["SpellBarWidth"]); statusbar2:SetHeight(4);
	statusbar2:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 4-rewatch_loadInt["HealthBarHeight"]);
	statusbar2:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	statusbar2:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar"); statusbar2:SetMinMaxValues(0, 1); statusbar2:SetValue(0);
	-- color it correctly
	local pt = UnitPowerType(player);
	if(pt == 0) then statusbar2:SetStatusBarColor(0.0, 0.0, 0.6, 0.8);
	elseif(pt == 1) then statusbar2:SetStatusBarColor(0.6, 0.0, 0.0, 0.8);
	elseif(pt == 6) then statusbar2:SetStatusBarColor(0.85, 0.15, 0.8, 0.8);
	else statusbar2:SetStatusBarColor(0.95, 0.85, 0.15, 0.8); end;
	-- overlay target/remove button
	local tgb = CreateFrame("BUTTON", nil, statusbar, "SecureActionButtonTemplate");
	tgb:SetWidth(statusbar:GetWidth()); tgb:SetHeight(statusbar:GetHeight()); tgb:SetPoint("TOPLEFT", statusbar, "TOPLEFT", 0, 0);
	tgb:RegisterForClicks("LeftButtonDown"); tgb:SetAttribute("type1", "target"); tgb:SetAttribute("unit", player);
	tgb:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square.blp");
	tgb:SetScript("OnMouseDown", function() if(arg1 == "RightButton") then
		rewatch_DropDown.relativeTo = frame; rewatch_RightClickMenuTable["selectedPlayer"] = player;
		ToggleDropDownMenu(1, nil, rewatch_DropDown, "rewatch_DropDown", -10, -10); end;
	end);
	tgb:SetScript("OnEnter", function() rewatch_SetTooltip(player); rewatch_bars[rewatch_GetPlayer(player)]["Hover"] = 1; end);
	tgb:SetScript("OnLeave", function() rewatch_tooltip:SetOwner(WorldFrame, "ANCHOR_NONE"); rewatch_bars[rewatch_GetPlayer(player)]["Hover"] = 2; end);
	-- save player data
	rewatch_bars[rewatch_i]["UnitGUID"] = nil; if(UnitExists(player)) then rewatch_bars[rewatch_i]["UnitGUID"] = UnitGUID(player); end;
	rewatch_bars[rewatch_i]["Frame"] = frame; rewatch_bars[rewatch_i]["Player"] = player;
	rewatch_bars[rewatch_i]["PlayerBar"] = statusbar; rewatch_bars[rewatch_i]["ManaBar"] = statusbar2;
	rewatch_bars[rewatch_i][rewatch_loc["lifebloom"]] = 0; rewatch_bars[rewatch_i]["LifebloomStacks"] = 0;
	rewatch_bars[rewatch_i][rewatch_loc["rejuvenation"]] = 0; rewatch_bars[rewatch_i][rewatch_loc["regrowth"]] = 0;
	rewatch_bars[rewatch_i][rewatch_loc["wildgrowth"]] = 0;
	rewatch_bars[rewatch_i][rewatch_loc["lifebloom"].."Bar"] = rewatch_CreateBar(rewatch_loc["lifebloom"], rewatch_i);
	rewatch_bars[rewatch_i][rewatch_loc["rejuvenation"].."Bar"] = rewatch_CreateBar(rewatch_loc["rejuvenation"], rewatch_i);
	if(rewatch_loadInt["WildGrowth"] == 1) then
		rewatch_bars[rewatch_i][rewatch_loc["wildgrowth"].."Bar"] = rewatch_CreateBar(rewatch_loc["wildgrowth"], rewatch_i);
	end;
	rewatch_bars[rewatch_i][rewatch_loc["regrowth"].."Bar"] = rewatch_CreateBar(rewatch_loc["regrowth"], rewatch_i);
	rewatch_bars[rewatch_i]["SwiftmendButton"] = rewatch_CreateButton(rewatch_loc["swiftmend"], rewatch_i, "Interface\\Icons\\INV_Relics_IdolofRejuvenation.blp");
		local smbcd = CreateFrame("Cooldown", "SwiftmendButtonCD"..rewatch_i, rewatch_bars[rewatch_i]["SwiftmendButton"], "CooldownFrameTemplate");
		rewatch_bars[rewatch_i]["SwiftmendButton"].cooldown = smbcd; smbcd:SetPoint("CENTER", 0, -1);
		smbcd:SetWidth(rewatch_bars[rewatch_i]["SwiftmendButton"]:GetWidth()); smbcd:SetHeight(rewatch_bars[rewatch_i]["SwiftmendButton"]:GetHeight()); smbcd:Hide();
	rewatch_bars[rewatch_i]["AbolishPoisonButton"] = rewatch_CreateButton(rewatch_loc["abolishpoison"], rewatch_i, "Interface\\Icons\\Spell_Nature_NullifyPoison_02.blp");
	rewatch_bars[rewatch_i]["DecurseButton"] = rewatch_CreateButton(rewatch_loc["removecurse"], rewatch_i, "Interface\\Icons\\Spell_Shadow_Curse.blp");
	rewatch_bars[rewatch_i]["HealingTouchButton"] = rewatch_CreateButton(rewatch_loc["healingtouch"], rewatch_i, "Interface\\Icons\\Spell_Nature_HealingTouch.blp");
	rewatch_bars[rewatch_i]["NourishButton"] = rewatch_CreateButton(rewatch_loc["nourish"], rewatch_i, "Interface\\Icons\\Ability_Druid_Nourish.blp");
	rewatch_bars[rewatch_i]["Curse"] = nil; rewatch_bars[rewatch_i]["Poison"] = nil; rewatch_bars[rewatch_i]["Class"] = class; rewatch_bars[rewatch_i]["Hover"] = 0;
	-- increment the global index
	rewatch_i = rewatch_i+1; rewatch_AlterFrame(); rewatch_SnapToGrid(frame);
	
	-- return the inserted player's player table index
	return rewatch_GetPlayer(player);
end;

-- hide all bars and buttons from - and the player himself, by name
-- player: the name of the player to hide
-- return: void
-- PRE: Called by specific user request
function rewatch_HidePlayerByName(player)
	if(InCombatLockdown() == 1) then rewatch_Message(rewatch_loc["combatfailed"]);
	else
		-- get the index of this player
		local playerId = rewatch_GetPlayer(player);
		-- if this player exists, hide all bars and buttons from - and the player himself
		if(playerId > 0) then
			-- check for others
			local others = false;
			for i=1,rewatch_i-1 do local val = rewatch_bars[i]; if(val) then
				if(i ~= playerId) then others = true; break; end;
			end; end;
			-- if there are other people in the frame
			if(others) then
				-- hide the player
				rewatch_HidePlayer(playerId);
				-- prevent auto-adding grouped players automatically
				if((rewatch_loadInt["AutoGroup"] == 1) and (rewatch_InGroup(player)) and UnitIsPlayer(player) and UnitIsConnected(player)) then
					rewatch_load["AutoGroup"], rewatch_loadInt["AutoGroup"] = 0, 0;
					rewatch_OptionsFromData(true);
					rewatch_Message(rewatch_loc["setautogroupauto0"]);
				end;
			else rewatch_Message(rewatch_loc["removefailed"]); end;
		end;
	end;
	
	-- return
	return;
end;

-- hide all bars and buttons from - and the player himself
-- playerId: the table index of the player to hide
-- return: void
function rewatch_HidePlayer(playerId)
	-- return if in combat
	if(InCombatLockdown() == 1) then return; end;
	
	-- remove the bar
	local parent = rewatch_bars[playerId]["Frame"]:GetParent();
	rewatch_bars[playerId]["PlayerBar"]:Hide();
	rewatch_bars[playerId][rewatch_loc["lifebloom"].."Bar"]:Hide();
	rewatch_bars[playerId][rewatch_loc["rejuvenation"].."Bar"]:Hide();
	if(rewatch_bars[playerId][rewatch_loc["wildgrowth"].."Bar"]) then
			rewatch_bars[playerId][rewatch_loc["wildgrowth"].."Bar"]:Hide();
	end;
	rewatch_bars[playerId][rewatch_loc["regrowth"].."Bar"]:Hide();
	rewatch_bars[playerId]["SwiftmendButton"]:Hide();
	rewatch_bars[playerId]["AbolishPoisonButton"]:Hide();
	rewatch_bars[playerId]["DecurseButton"]:Hide();
	rewatch_bars[playerId]["HealingTouchButton"]:Hide();
	rewatch_bars[playerId]["NourishButton"]:Hide();
	rewatch_bars[playerId]["Frame"]:Hide();
	rewatch_bars[playerId]["Frame"]:SetParent(nil);
	rewatch_bars[playerId] = nil;
	
	-- update the frame width/height
	if(parent ~= UIParent) then rewatch_AlterFrame(parent); end;
	
	-- return
	return;
end;

-- build a frame
-- return: void
function rewatch_BuildFrame()
	-- create it
	local frame = CreateFrame("FRAME", "Rewatch_Frame"..table.getn(rewatch_f), UIParent);
	-- set proper dimentions and location
	frame:SetWidth(100); frame:SetHeight(100);
	frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT"); frame:EnableMouse(true); frame:SetMovable(true);
	-- set looks
	frame:SetBackdrop({bgFile = nil, edgeFile = nil, tile = 1, tileSize = 10, edgeSize = 10, insets = { left = 3, right = 3, top = 3, bottom = 3 }});
	-- make it draggable
	frame:SetScript("OnMouseDown", function() if(not rewatch_loadInt["Lock"]) then frame:StartMoving(); end; end);
	frame:SetScript("OnMouseUp", function() frame:StopMovingOrSizing(); end);
	frame:SetScript("OnEnter", function () frame:SetBackdrop({bgFile = nil, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 10, edgeSize = 10, insets = { left = 3, right = 3, top = 3, bottom = 3 }}); end);
	frame:SetScript("OnLeave", function () frame:SetBackdrop({bgFile = nil, edgeFile = nil, tile = 1, tileSize = 10, edgeSize = 10, insets = { left = 3, right = 3, top = 3, bottom = 3 }}); end);
	-- add the frame to the table
	table.insert(rewatch_f, frame);
	-- create cooldown overlay and add it to it's own table
	local gcd = CreateFrame("Cooldown", "FrameCD", frame, "CooldownFrameTemplate"); gcd:SetAlpha(1);
	gcd:SetPoint("CENTER", 0, -1); gcd:SetWidth(frame:GetWidth()); gcd:SetHeight(frame:GetHeight()); gcd:Hide();
	table.insert(rewatch_gcds, gcd);
	
	-- return
	return;
end;

-- function set set the options frame values
-- get: boolean if the function will get data (true) or set data (false) from the options frame
-- return: void
function rewatch_OptionsFromData(get)
	-- get the childeren elements
	local children = { rewatch_options:GetChildren() };
	for _, child in ipairs(children) do
		-- if it's the slider, set or get his data
		if(child:GetName() == "Rewatch_AlphaSlider") then
			if(get) then child:SetValue(rewatch_loadInt["GcdAlpha"]);
			else rewatch_load["GcdAlpha"], rewatch_loadInt["GcdAlpha"] = child:GetValue(), child:GetValue(); end;
		-- if it's the autogroup checkbutton, set or get his data
		elseif(child:GetName() == "Rewatch_AutoGroupCB") then
			if(get) then if(rewatch_loadInt["AutoGroup"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["AutoGroup"], rewatch_loadInt["AutoGroup"] = 1, 1;
				else
					if(rewatch_loadInt["AutoGroup"] == 1) then rewatch_load["AutoGroup"], rewatch_loadInt["AutoGroup"] = 0, 0; rewatch_changed = true;
					else rewatch_load["AutoGroup"], rewatch_loadInt["AutoGroup"] = 0, 0; end;
				end; end;
		-- if it's the hidesolo checkbutton, set or get his data
		elseif(child:GetName() == "Rewatch_SoloHideCB") then
			if(get) then if(rewatch_loadInt["HideSolo"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["HideSolo"], rewatch_loadInt["HideSolo"] = 1, 1;
				else rewatch_load["HideSolo"], rewatch_loadInt["HideSolo"] = 0, 0; end; end;
		-- if it's the hide checkbutton, set or get his data
		elseif(child:GetName() == "Rewatch_HideCB") then
			if(get) then if(rewatch_loadInt["Hide"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["Hide"], rewatch_loadInt["Hide"] = 1, 1;
				else rewatch_load["Hide"], rewatch_loadInt["Hide"] = 0, 0; end; end;
		-- if it's the nature's splendor checkbutton, set or get his data
		elseif(child:GetName() == "Rewatch_NaturesSplendorCB") then
			if(get) then if(rewatch_loadInt["NaturesSplendor"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["NaturesSplendor"], rewatch_loadInt["NaturesSplendor"] = 1, 1;
				else rewatch_load["NaturesSplendor"], rewatch_loadInt["NaturesSplendor"] = 0, 0; end; end;
		-- if it's the glyph of lifebloom checkbox, set or get this data
		elseif(child:GetName() == "Rewatch_GlyphOfLifebloomCB") then
			if(get) then if(rewatch_loadInt["GoLB"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["GoLB"], rewatch_loadInt["GoLB"] = 1, 1;
				else rewatch_load["GoLB"], rewatch_loadInt["GoLB"] = 0, 0; end; end;
		-- if it's the glyph of swiftmend checkbox, set or get this data
		elseif(child:GetName() == "Rewatch_GlyphOfSwiftmendCB") then
			if(get) then if(rewatch_loadInt["GoSM"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["GoSM"], rewatch_loadInt["GoSM"] = 1, 1;
				else rewatch_load["GoSM"], rewatch_loadInt["GoSM"] = 0, 0; end; end;
		-- if it's the t5 set bonus checkbox, set or get this data
		elseif(child:GetName() == "Rewatch_T5CB") then
			if(get) then if(rewatch_loadInt["T5"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["T5"], rewatch_loadInt["T5"] = 1, 1;
				else rewatch_load["T5"], rewatch_loadInt["T5"] = 0, 0; end; end;
		-- if it's the wild growth checkbox, set or get this data
		elseif(child:GetName() == "Rewatch_WGCB") then
			if(get) then if(rewatch_loadInt["WildGrowth"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["WildGrowth"], rewatch_loadInt["WildGrowth"] = 1, 1;
				else rewatch_load["WildGrowth"], rewatch_loadInt["WildGrowth"] = 0, 0; end; end;
		-- if it's the lock checkbox, set or get this data
		elseif(child:GetName() == "Rewatch_LockCB") then
			if(get) then if(rewatch_loadInt["Lock"]) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_loadInt["Lock"] = true; else rewatch_loadInt["Lock"] = false; end; end;
		-- if it's the lock checkbox, set or get this data
		elseif(child:GetName() == "Rewatch_LabelsCB") then
			if(get) then if(rewatch_loadInt["Labels"] == 1) then child:SetChecked(true); else child:SetChecked(false); end;
			else if(child:GetChecked()) then rewatch_load["Labels"] = 1; rewatch_loadInt["Labels"] = 1; else rewatch_loadInt["Labels"] = 0; rewatch_load["Labels"] = 0; end; end;
		end;
	end;
	-- dimentions
	children = { rewatch_options2:GetChildren() };
	for _, child in ipairs(children) do
		if(child:GetName() == "Rewatch_SlideHBH") then
			if(get) then child:SetValue(rewatch_loadInt["HealthBarHeight"]); getglobal("Rewatch_SlideHBHText"):SetText(rewatch_loadInt["HealthBarHeight"]);
			else rewatch_load["HealthBarHeight"], rewatch_loadInt["HealthBarHeight"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		elseif(child:GetName() == "Rewatch_SlideCBW") then
			if(get) then child:SetValue(rewatch_loadInt["SpellBarWidth"]); getglobal("Rewatch_SlideCBWText"):SetText(rewatch_loadInt["SpellBarWidth"]);
			else rewatch_load["SpellBarWidth"], rewatch_loadInt["SpellBarWidth"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		elseif(child:GetName() == "Rewatch_SlideCBH") then
			if(get) then child:SetValue(rewatch_loadInt["SpellBarHeight"]); getglobal("Rewatch_SlideCBHText"):SetText(rewatch_loadInt["SpellBarHeight"]);
			else rewatch_load["SpellBarHeight"], rewatch_loadInt["SpellBarHeight"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		elseif(child:GetName() == "Rewatch_SlideCBM") then
			if(get) then child:SetValue(rewatch_loadInt["SpellBarMargin"]); getglobal("Rewatch_SlideCBMText"):SetText(rewatch_loadInt["SpellBarMargin"]);
			else rewatch_load["SpellBarMargin"], rewatch_loadInt["SpellBarMargin"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		elseif(child:GetName() == "Rewatch_SlideBW") then
			if(get) then child:SetValue(rewatch_loadInt["SmallButtonWidth"]); getglobal("Rewatch_SlideBWText"):SetText(rewatch_loadInt["SmallButtonWidth"]);
			else rewatch_load["SmallButtonWidth"], rewatch_loadInt["SmallButtonWidth"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		elseif(child:GetName() == "Rewatch_SlideBH") then
			if(get) then child:SetValue(rewatch_loadInt["SmallButtonHeight"]); getglobal("Rewatch_SlideBHText"):SetText(rewatch_loadInt["SmallButtonHeight"]);
			else rewatch_load["SmallButtonHeight"], rewatch_loadInt["SmallButtonHeight"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		elseif(child:GetName() == "Rewatch_SlideBM") then
			if(get) then child:SetValue(rewatch_loadInt["SmallButtonMargin"]); getglobal("Rewatch_SlideBMText"):SetText(rewatch_loadInt["SmallButtonMargin"]);
			else rewatch_load["SmallButtonMargin"], rewatch_loadInt["SmallButtonMargin"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		elseif(child:GetName() == "Rewatch_SlideSB") then
			if(get) then child:SetValue(rewatch_loadInt["SideBar"]); getglobal("Rewatch_SlideSBText"):SetText(rewatch_loadInt["SideBar"]);
			else rewatch_load["SideBar"], rewatch_loadInt["SideBar"] = math.floor(child:GetValue()+0.5), math.floor(child:GetValue()+0.5); end;
		end;
	end;
	-- apply changes
	if(not get) then
		rewatch_UpdateOffset();
		for _, cd in ipairs(rewatch_gcds) do cd:SetAlpha(rewatch_loadInt["GcdAlpha"]); end;
		if(((rewatch_i == 2) and (rewatch_loadInt["HideSolo"] == 1)) or (rewatch_loadInt["Hide"] == 1)) then rewatch_f[1]:Hide(); else rewatch_ShowFrame(); end;
	end;
end;

-- update a bar color and it's swatch
-- return: void
function rewatch_UpdateBLBColor()
	local rc, gc, bc = ColorPickerFrame:GetColorRGB(); rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]] = { r=rc, g=gc, b=bc };
	rewatch_load["BarColor"..rewatch_loc["lifebloom"]] = rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]]; rewatch_UpdateSwatch();
end;
function rewatch_UpdateBLB2Color()
	local rc, gc, bc = ColorPickerFrame:GetColorRGB(); rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"] = { r=rc, g=gc, b=bc };
	rewatch_load["BarColor"..rewatch_loc["lifebloom"].."2"] = rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"]; rewatch_UpdateSwatch();
end;
function rewatch_UpdateBLB3Color()
	local rc, gc, bc = ColorPickerFrame:GetColorRGB(); rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"] = { r=rc, g=gc, b=bc };
	rewatch_load["BarColor"..rewatch_loc["lifebloom"].."3"] = rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"]; rewatch_UpdateSwatch();
end;
function rewatch_UpdateBREJColor()
	local rc, gc, bc = ColorPickerFrame:GetColorRGB(); rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]] = { r=rc, g=gc, b=bc };
	rewatch_load["BarColor"..rewatch_loc["rejuvenation"]] = rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]]; rewatch_UpdateSwatch();
end;
function rewatch_UpdateBREWColor()
	local rc, gc, bc = ColorPickerFrame:GetColorRGB(); rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]] = { r=rc, g=gc, b=bc };
	rewatch_load["BarColor"..rewatch_loc["regrowth"]] = rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]]; rewatch_UpdateSwatch();
end;
function rewatch_UpdateBWGColor()
	local rc, gc, bc = ColorPickerFrame:GetColorRGB(); rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]] = { r=rc, g=gc, b=bc };
	rewatch_load["BarColor"..rewatch_loc["wildgrowth"]] = rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]]; rewatch_UpdateSwatch();
end;

-- update the frame color and it's swatch
-- return: void
function rewatch_UpdateFColor()
	local rc, gc, bc = ColorPickerFrame:GetColorRGB();
	local ac = 1-OpacitySliderFrame:GetValue();
	rewatch_loadInt["FrameColor"] = { r=rc, g=gc, b=bc, a=ac};
	rewatch_load["FrameColor"] = rewatch_loadInt["FrameColor"];
	for i=1,rewatch_i-1 do local val = rewatch_bars[i]; if(val) then val["Frame"]:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a); end; end;
	rewatch_UpdateSwatch();
end;

-- update the swatches
-- return: void
function rewatch_UpdateSwatch()
	local children = { rewatch_options:GetChildren() };
	for _, child in ipairs(children) do
		-- if it's the framecolor colorpicker, get this data
		if(child:GetName() == "Rewatch_FrameCP") then
			child:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a);
		-- if it's a barcolor colorpicker, get that data
		elseif(child:GetName() == "Rewatch_BarCP"..rewatch_loc["lifebloom"]) then
			child:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].b, 0.8);
		elseif(child:GetName() == "Rewatch_BarCP"..rewatch_loc["lifebloom"].."2") then
			child:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].b, 0.8);
		elseif(child:GetName() == "Rewatch_BarCP"..rewatch_loc["lifebloom"].."3") then
			child:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].b, 0.8);
		elseif(child:GetName() == "Rewatch_BarCP"..rewatch_loc["rejuvenation"]) then
			child:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].r, rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].g, rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].b, 0.8);
		elseif(child:GetName() == "Rewatch_BarCP"..rewatch_loc["regrowth"]) then
			child:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].r, rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].g, rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].b, 0.8);
		elseif(child:GetName() == "Rewatch_BarCP"..rewatch_loc["wildgrowth"]) then
			child:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].r, rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].g, rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].b, 0.8);
		end;
	end;
end;

-- process the sent commands
-- cmd: the command that has to be executed
-- return: void
function rewatch_SlashCommandHandler(cmd)
	-- when there's a command typed
	if(cmd) then
		-- declaration and initialisation
		local pos, commands = 0, {};
		for st, sp in function() return string.find(cmd, " ", pos, true) end do
			table.insert(commands, string.sub(cmd, pos, st-1));
			pos = sp + 1;
		end; table.insert(commands, string.sub(cmd, pos));
		-- on a help request, reply with the localisation help table
		if(string.lower(commands[1]) == "help") then
			for _,val in ipairs(rewatch_loc["help"]) do
				rewatch_Message(val);
			end;
		-- if the user wants to add a player manually
		elseif(string.lower(commands[1]) == "add") then
			if(InCombatLockdown() == 1) then rewatch_Message(rewatch_loc["combatfailed"]);
			elseif(commands[2]) then
				if(rewatch_GetPlayer(commands[2]) < 0) then
					if(rewatch_InGroup(commands[2])) then rewatch_AddPlayer(commands[2]);
					elseif(commands[3]) then
						if(string.lower(commands[3]) == "always") then rewatch_AddPlayer(commands[2]);
						else rewatch_Message(rewatch_loc["notingroup"]); end;
					else rewatch_Message(rewatch_loc["notingroup"]); end;
				end;
			elseif(UnitName("target")) then if(rewatch_GetPlayer(UnitName("target")) < 0) then rewatch_AddPlayer(UnitName("target")); end;
			else rewatch_Message(rewatch_loc["noplayer"]); end;
		-- if the user wants to resort the list (clear and processgroup)
		elseif(string.lower(commands[1]) == "sort") then
			if(rewatch_loadInt["AutoGroup"] == 0) then
				rewatch_Message(rewatch_loc["nosort"]);
			else
				rewatch_Clear(); rewatch_changed = true;
				rewatch_Message(rewatch_loc["sorted"]);
			end;
		-- if the user wants to clear the player list
		elseif(string.lower(commands[1]) == "clear") then
			rewatch_Clear();
			rewatch_Message(rewatch_loc["cleared"]);
		-- if the user wants to set the gcd alpha
		elseif(string.lower(commands[1]) == "gcdalpha") then
			if(not tonumber(commands[2])) then rewatch_Message(rewatch_loc["nonumber"]);
			elseif((tonumber(commands[2]) < 0) or (tonumber(commands[2]) > 1)) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["GcdAlpha"] = tonumber(commands[2]); rewatch_loadInt["GcdAlpha"] = rewatch_load["GcdAlpha"];
				for _, cd in ipairs(rewatch_gcds) do cd:SetAlpha(rewatch_loadInt["GcdAlpha"]); end;
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["setalpha"]..commands[2]);
			end;
		-- if the user wants to set the hide solo feature
		elseif(string.lower(commands[1]) == "hidesolo") then
			if(not((commands[2] == "0") or (commands[2] == "1"))) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["HideSolo"] = tonumber(commands[2]); rewatch_loadInt["HideSolo"] = rewatch_load["HideSolo"];
				if(((rewatch_i == 2) and (rewatch_load["HideSolo"] == 1)) or (rewatch_["Hide"] == 1)) then rewatch_f[1]:Hide(); else rewatch_ShowFrame(); end;
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["sethidesolo"..commands[2]]);
			end;
		-- if the user wants to set the natures splendor talent recognition feature
		elseif(string.lower(commands[1]) == "naturessplendor") then
			if(not((commands[2] == "0") or (commands[2] == "1"))) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["NaturesSplendor"] = tonumber(commands[2]); rewatch_loadInt["NaturesSplendor"] = rewatch_load["NaturesSplendor"];
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["setnaturessplendor"..commands[2]]);
			end;
		-- if the user wants to set the glyph of lifebloom indicator
		elseif(string.lower(commands[1]) == "glyphoflifebloom") then
			if(not((commands[2] == "0") or (commands[2] == "1"))) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["GoLB"] = tonumber(commands[2]); rewatch_loadInt["GoLB"] = rewatch_load["GoLB"];
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["setgolb"..commands[2]]);
			end;
		-- if the user wants to set the glyph of swiftmend indicator
		elseif(string.lower(commands[1]) == "glyphofswiftmend") then
			if(not((commands[2] == "0") or (commands[2] == "1"))) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["GoSM"] = tonumber(commands[2]); rewatch_loadInt["GoSM"] = rewatch_load["GoSM"];
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["setgosm"..commands[2]]);
			end;
		-- if the user wants to set the t5 (2) bonus indicator
		elseif(string.lower(commands[1]) == "t5") then
			if(not((commands[2] == "0") or (commands[2] == "1"))) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["T5"] = tonumber(commands[2]); rewatch_loadInt["T5"] = rewatch_load["T5"];
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["sett5"..commands[2]]);
			end;
		-- if the user wants to set the hide solo feature
		elseif(string.lower(commands[1]) == "hide") then
			if(not((commands[2] == "0") or (commands[2] == "1"))) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["Hide"] = tonumber(commands[2]); rewatch_loadInt["Hide"] = rewatch_load["Hide"];
				if(((rewatch_i == 2) and (rewatch_load["HideSolo"] == 1)) or (rewatch_load["Hide"] == 1)) then rewatch_f[1]:Hide(); else rewatch_ShowFrame(); end;
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["sethide"..commands[2]]);
			end;
		-- if the user wants to set the autoadjust list to group feature
		elseif(string.lower(commands[1]) == "autogroup") then
			if(not((commands[2] == "0") or (commands[2] == "1"))) then rewatch_Message(rewatch_loc["nonumber"]);
			else
				rewatch_load["AutoGroup"] = tonumber(commands[2]); rewatch_loadInt["AutoGroup"] = rewatch_load["AutoGroup"];
				rewatch_OptionsFromData(true);
				rewatch_Message(rewatch_loc["setautogroup"..commands[2]]);
				rewatch_changed = true;
			end;
		-- if the user wants to use the lock feature
		elseif(string.lower(commands[1]) == "lock") then
			rewatch_loadInt["Lock"] = true; rewatch_OptionsFromData(true);
			rewatch_Message(rewatch_loc["locked"]);
		-- if the user wants to use the unlock feature
		elseif(string.lower(commands[1]) == "unlock") then
			rewatch_loadInt["Lock"] = false; rewatch_OptionsFromData(true);
			rewatch_Message(rewatch_loc["unlocked"]);
		-- if the user demanded a druid buff check
		elseif(string.lower(commands[1]) == "check") then
			rewatch_BuffCheck();
		-- if the user wants to check his version
		elseif(string.lower(commands[1]) == "version") then
			rewatch_Message("Rewatch v"..rewatch_versioni);
		-- if the user wants to toggle the settings GUI
		elseif(string.lower(commands[1]) == "options") then
			rewatch_ChangedDimentions = false;
			InterfaceOptionsFrame_OpenToCategory("Rewatch");
		-- if the user wants something else (unsupported)
		elseif(string.len(commands[1]) > 0) then rewatch_Message(rewatch_loc["invalid_command"]);
		else rewatch_Message(rewatch_loc["credits"]); end;
	-- if there's no command typed
	else rewatch_Message(rewatch_loc["credits"]); end;
	
	-- return
	return;
end;


--// INITIALISE //----------------------------------------------------------------------------------------------------------------------------------------------------------------

-- make the addon stop here if the user isn't a druid
if((select(2, UnitClass("player"))) ~= "DRUID") then return; end;
-- build event logger
rewatch_events = CreateFrame("FRAME", nil, UIParent); rewatch_events:SetWidth(0); rewatch_events:SetHeight(0);
rewatch_events:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED"); rewatch_events:RegisterEvent("PARTY_MEMBERS_CHANGED");
rewatch_events:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE"); rewatch_events:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
-- initialise all vars
rewatch_ChangedDimentions = false;
rewatch_f, rewatch_bars, rewatch_abs, rewatch_i, rewatch_RightClickMenuTable, rewatch_DropDown = {},  {}, {}, 1, {}, nil;
rewatch_loadInt = {
	Loaded = false; GcdAlpha = 1; HideSolo = 0; AutoGroup = 1; NaturesSplendor = 0; GoLB = 0; GoSM = 0; T5 = 0; FrameColor = { r=0; g=0; b=0; a=0.3 };
	SpellBarWidth = 75; SpellBarHeight = 8; SpellBarMargin = 0; NumFramesWide = 5; SmallButtonWidth = 19; SmallButtonHeight = 19; SmallButtonMargin = 1; FrameWidth = 1; FrameHeight = 1;
	Lock = false; WildGrowth = 1; Font = "GameFontHighlightSmall"; HealthBarHeight = 18; Labels = 0; SideBar = 7
};
rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]] = { r=0; g=0; b=0 }; rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"] = { r=0; g=0; b=0 }; rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"] = { r=0; g=0; b=0 };
rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]] = { r=0; g=0; b=0 }; rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]] = { r=0; g=0; b=0 }; rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]] = { r=0; g=0; b=0 };
rewatch_tooltip, rewatch_gcds, rewatch_changed, rewatch_options, rewatch_extraTime = nil, {}, true, nil, {};
rewatch_extraTime[rewatch_loc["rejuvenation"]] = 3; rewatch_extraTime[rewatch_loc["regrowth"]] = 6; rewatch_extraTime[rewatch_loc["lifebloom"]] = 2;  rewatch_extraTime[rewatch_loc["wildgrowth"]] = 0;
-- add the slash command handler
SLASH_REWATCH1 = "/Rewatch";
SLASH_REWATCH2 = "/rewatch";
SLASH_REWATCH3 = "/Rew";
SLASH_REWATCH4 = "/rew";
SlashCmdList["REWATCH"] = function(cmd)
	rewatch_SlashCommandHandler(cmd);
end;


--// SCRIPT //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- create the outline frame
rewatch_BuildFrame();

-- create the rightclick menu frame
rewatch_RightClickMenuTable = { closeMenu = "Close menu", removePlayer = "Remove player", selectedPlayer = ""};
rewatch_DropDown = CreateFrame("FRAME", "rewatch_DropDownFrame", nil, "UIDropDownMenuTemplate");
rewatch_DropDown.point = "TOPLEFT";
rewatch_DropDown.relativePoint = "TOPRIGHT";
rewatch_DropDown.displayMode = "MENU";
rewatch_DropDown.relativeTo = rewatch_f[1];
UIDropDownMenu_Initialize(rewatch_DropDownFrame, function(self)
	for name, title in pairs(rewatch_RightClickMenuTable) do
		local info = UIDropDownMenu_CreateInfo();
		if(name == "selectedPlayer") then info.isTitle = true; end;
		info.text = title; info.value = name; info.owner = rewatch_DropDown; info.notCheckable = true;
		info.func = function(self)
			if(self.value == "removePlayer") then rewatch_HidePlayerByName(rewatch_RightClickMenuTable["selectedPlayer"]); end; 
		end;
		UIDropDownMenu_AddButton(info);
	end;
end, "MENU");
UIDropDownMenu_SetWidth(rewatch_DropDown, 90);

-- create the options frame
rewatch_options = CreateFrame("FRAME", "Rewatch_Options", UIParent); rewatch_options.name = "Rewatch";
rewatch_options2 = CreateFrame("FRAME", "Rewatch_Options2", UIParent); rewatch_options2.name = "Dimentions"; rewatch_options2.parent = "Rewatch";
-- slider
local alphaSliderT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
alphaSliderT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -10); alphaSliderT:SetText(rewatch_loc["gcdText"]);
local alphaSlider = CreateFrame("SLIDER", "Rewatch_AlphaSlider", rewatch_options, "OptionsSliderTemplate");
alphaSlider:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 213, -25); alphaSlider:SetMinMaxValues(0, 1); alphaSlider:SetValueStep(0.1);
getglobal("Rewatch_AlphaSliderLow"):SetText(rewatch_loc["invisible"]); getglobal("Rewatch_AlphaSliderHigh"):SetText(rewatch_loc["visible"]);
-- frame color
local frameCPT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
frameCPT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 15, -60); frameCPT:SetText(rewatch_loc["frameback"]);
local frameCP = CreateFrame("BUTTON", "Rewatch_FrameCP", rewatch_options); frameCP:SetWidth(18); frameCP:SetHeight(18);
frameCP:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
frameCP:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a); frameCP:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 213, -60);
frameCP:SetScript("OnClick", function() ColorPickerFrame:Hide(); OpacitySliderFrame:SetValue((1-rewatch_loadInt["FrameColor"].a)); ColorPickerFrame.opacityFunc = rewatch_UpdateFColor; ColorPickerFrame.func = rewatch_UpdateFColor; ColorPickerFrame:SetColorRGB(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b); ColorPickerFrame.hasOpacity = true; ColorPickerFrame.opacity = (1-rewatch_loadInt["FrameColor"].a); OpacitySliderFrame:SetValue((1-rewatch_loadInt["FrameColor"].a)); ColorPickerFrame:Show(); end);
local frameCPR = CreateFrame("BUTTON", "Rewatch_FrameCPR", rewatch_options, "OptionsButtonTemplate"); frameCPR:SetText(rewatch_loc["reset"]);
frameCPR:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 235, -58); frameCPR:SetScript("OnClick", function() rewatch_loadInt["FrameColor"] = { r=0; g=0; b=0; a=0.3}; rewatch_load["FrameColor"] = rewatch_loadInt["FrameColor"]; rewatch_UpdateSwatch(); for i=1,rewatch_i-1 do local val = rewatch_bars[i]; if(val) then val["Frame"]:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a); end; end; end);
-- bar colors
local barCPT_lb = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
barCPT_lb:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 15, -80); barCPT_lb:SetText(rewatch_loc["barback"].." "..rewatch_loc["lifebloom"]);
local barCPT_rej = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
barCPT_rej:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 15, -100); barCPT_rej:SetText(rewatch_loc["barback"].." "..rewatch_loc["rejuvenation"]);
local barCPT_reg = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
barCPT_reg:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 15, -120); barCPT_reg:SetText(rewatch_loc["barback"].." "..rewatch_loc["regrowth"]);
local barCPT_wg = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
barCPT_wg:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 15, -140); barCPT_wg:SetText(rewatch_loc["barback"].." "..rewatch_loc["wildgrowth"]);
--[[lb stack colors]]--
local barCP_lb = CreateFrame("BUTTON", "Rewatch_BarCP"..rewatch_loc["lifebloom"], rewatch_options); barCP_lb:SetWidth(18); barCP_lb:SetHeight(18);
barCP_lb:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
barCP_lb:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].b, 0.8); barCP_lb:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 177, -80);
barCP_lb:SetScript("OnClick", function() ColorPickerFrame:Hide(); ColorPickerFrame.func = rewatch_UpdateBLBColor; ColorPickerFrame:SetColorRGB(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]].b); ColorPickerFrame.hasOpacity = false; ColorPickerFrame.opacityFunc = nil; ColorPickerFrame:Show(); end);
local barCP_lb2 = CreateFrame("BUTTON", "Rewatch_BarCP"..rewatch_loc["lifebloom"].."2", rewatch_options); barCP_lb2:SetWidth(18); barCP_lb2:SetHeight(18);
barCP_lb2:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
barCP_lb2:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].b, 0.8); barCP_lb2:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 195, -80);
barCP_lb2:SetScript("OnClick", function() ColorPickerFrame:Hide(); ColorPickerFrame.func = rewatch_UpdateBLB2Color; ColorPickerFrame:SetColorRGB(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"].b); ColorPickerFrame.hasOpacity = false; ColorPickerFrame.opacityFunc = nil; ColorPickerFrame:Show(); end);
local barCP_lb3 = CreateFrame("BUTTON", "Rewatch_BarCP"..rewatch_loc["lifebloom"].."3", rewatch_options); barCP_lb3:SetWidth(18); barCP_lb3:SetHeight(18);
barCP_lb3:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
barCP_lb3:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].b, 0.8); barCP_lb3:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 213, -80);
barCP_lb3:SetScript("OnClick", function() ColorPickerFrame:Hide(); ColorPickerFrame.func = rewatch_UpdateBLB3Color; ColorPickerFrame:SetColorRGB(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"].b); ColorPickerFrame.hasOpacity = false; ColorPickerFrame.opacityFunc = nil; ColorPickerFrame:Show(); end);
--[[/lb stack colors]]--
local barCP_rej = CreateFrame("BUTTON", "Rewatch_BarCP"..rewatch_loc["rejuvenation"], rewatch_options); barCP_rej:SetWidth(18); barCP_rej:SetHeight(18);
barCP_rej:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
barCP_rej:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].r, rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].g, rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].b, 0.8); barCP_rej:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 213, -100);
barCP_rej:SetScript("OnClick", function() ColorPickerFrame:Hide(); ColorPickerFrame.func = rewatch_UpdateBREJColor; ColorPickerFrame:SetColorRGB(rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].r, rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].g, rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]].b); ColorPickerFrame.hasOpacity = false; ColorPickerFrame.opacityFunc = nil; ColorPickerFrame:Show(); end);
local barCP_reg = CreateFrame("BUTTON", "Rewatch_BarCP"..rewatch_loc["regrowth"], rewatch_options); barCP_reg:SetWidth(18); barCP_reg:SetHeight(18);
barCP_reg:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
barCP_reg:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].r, rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].g, rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].b, 0.8); barCP_reg:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 213, -120);
barCP_reg:SetScript("OnClick", function() ColorPickerFrame:Hide(); ColorPickerFrame.func = rewatch_UpdateBREWColor; ColorPickerFrame:SetColorRGB(rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].r, rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].g, rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]].b); ColorPickerFrame.hasOpacity = false; ColorPickerFrame.opacityFunc = nil; ColorPickerFrame:Show(); end);
local barCP_wg = CreateFrame("BUTTON", "Rewatch_BarCP"..rewatch_loc["wildgrowth"], rewatch_options); barCP_wg:SetWidth(18); barCP_wg:SetHeight(18);
barCP_wg:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 5, edgeSize = 5, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
barCP_wg:SetBackdropColor(rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].r, rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].g, rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].b, 0.8); barCP_wg:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 213, -140);
barCP_wg:SetScript("OnClick", function() ColorPickerFrame:Hide(); ColorPickerFrame.func = rewatch_UpdateBWGColor; ColorPickerFrame:SetColorRGB(rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].r, rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].g, rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]].b); ColorPickerFrame.hasOpacity = false; ColorPickerFrame.opacityFunc = nil; ColorPickerFrame:Show(); end);
-- reset buttons
local barCPR_lb = CreateFrame("BUTTON", "Rewatch_BarCPR", rewatch_options, "OptionsButtonTemplate"); barCPR_lb:SetText(rewatch_loc["reset"]);
barCPR_lb:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 235, -78); barCPR_lb:SetScript("OnClick", function()
	rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]] = { r=0.6; g=0; b=0}; rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"] = { r=1; g=0.5; b=0}; rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"] = { r=0; g=0; b=0.8};
	rewatch_load["BarColor"..rewatch_loc["lifebloom"]] = rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]]; rewatch_load["BarColor"..rewatch_loc["lifebloom"].."2"] = rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."2"]; rewatch_load["BarColor"..rewatch_loc["lifebloom"].."3"] = rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"].."3"]; rewatch_UpdateSwatch();
end);
local barCPR_rej = CreateFrame("BUTTON", "Rewatch_BarCPR", rewatch_options, "OptionsButtonTemplate"); barCPR_rej:SetText(rewatch_loc["reset"]);
barCPR_rej:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 235, -98); barCPR_rej:SetScript("OnClick", function() rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]] = { r=0.85; g=0.15; b=0.80}; rewatch_load["BarColor"..rewatch_loc["rejuvenation"]] = rewatch_loadInt["BarColor"..rewatch_loc["rejuvenation"]]; rewatch_UpdateSwatch(); end);
local barCPR_reg = CreateFrame("BUTTON", "Rewatch_BarCPR", rewatch_options, "OptionsButtonTemplate"); barCPR_reg:SetText(rewatch_loc["reset"]);
barCPR_reg:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 235, -118); barCPR_reg:SetScript("OnClick", function() rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]] = { r=0.05; g=0.3; b=0.1}; rewatch_load["BarColor"..rewatch_loc["regrowth"]] = rewatch_loadInt["BarColor"..rewatch_loc["regrowth"]]; rewatch_UpdateSwatch(); end);
local barCPR_wg = CreateFrame("BUTTON", "Rewatch_BarCPR", rewatch_options, "OptionsButtonTemplate"); barCPR_wg:SetText(rewatch_loc["reset"]);
barCPR_wg:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 235, -138); barCPR_wg:SetScript("OnClick", function() rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]] = { r=0.5; g=0.8; b=0.3}; rewatch_load["BarColor"..rewatch_loc["wildgrowth"]] = rewatch_loadInt["BarColor"..rewatch_loc["wildgrowth"]]; rewatch_UpdateSwatch(); end);
-- left options
local hideCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
hideCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 50, -190); hideCBT:SetText(rewatch_loc["hide"]);
local hideCB = CreateFrame("CHECKBUTTON", "Rewatch_HideCB", rewatch_options, "OptionsCheckButtonTemplate");
hideCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -183);
local soloHideCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
soloHideCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 50, -210); soloHideCBT:SetText(rewatch_loc["hideSolo"]);
local soloHideCB = CreateFrame("CHECKBUTTON", "Rewatch_SoloHideCB", rewatch_options, "OptionsCheckButtonTemplate");
soloHideCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -203);
local autoGroupCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
autoGroupCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 50, -230); autoGroupCBT:SetText(rewatch_loc["autoAdjust"]);
local autoGroupCB = CreateFrame("CHECKBUTTON", "Rewatch_AutoGroupCB", rewatch_options, "OptionsCheckButtonTemplate");
autoGroupCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -223);
local lockCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
lockCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 50, -250); lockCBT:SetText("Lock");
local lockCB = CreateFrame("CHECKBUTTON", "Rewatch_LockCB", rewatch_options, "OptionsCheckButtonTemplate");
lockCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -243);
local labelsCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
labelsCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 50, -270); labelsCBT:SetText("Labels instead of timers?");
local labelsCB = CreateFrame("CHECKBUTTON", "Rewatch_LabelsCB", rewatch_options, "OptionsCheckButtonTemplate");
labelsCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -263);
labelsCB:SetScript("OnClick", function(self) rewatch_ChangedDimentions = true; end);
-- right options
local goSMCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
goSMCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 250, -190); goSMCBT:SetText(rewatch_loc["goSM"]);
local goSMCB = CreateFrame("CHECKBUTTON", "Rewatch_GlyphOfSwiftmendCB", rewatch_options, "OptionsCheckButtonTemplate");
goSMCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 210, -183);
local t5CBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
t5CBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 250, -210); t5CBT:SetText(rewatch_loc["t5"]);
local t5CB = CreateFrame("CHECKBUTTON", "Rewatch_T5CB", rewatch_options, "OptionsCheckButtonTemplate");
t5CB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 210, -203);
local naturesSplendorCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
naturesSplendorCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 250, -230); naturesSplendorCBT:SetText(rewatch_loc["naturesSplendor"]);
local naturesSplendorCB = CreateFrame("CHECKBUTTON", "Rewatch_NaturesSplendorCB", rewatch_options, "OptionsCheckButtonTemplate");
naturesSplendorCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 210, -223);
local goLBCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
goLBCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 250, -250); goLBCBT:SetText(rewatch_loc["goLB"]);
local goLBCB = CreateFrame("CHECKBUTTON", "Rewatch_GlyphOfLifebloomCB", rewatch_options, "OptionsCheckButtonTemplate");
goLBCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 210, -243);
local wgCBT = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
wgCBT:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 250, -270); wgCBT:SetText(rewatch_loc["talentedwg"]);
local wgCB = CreateFrame("CHECKBUTTON", "Rewatch_WGCB", rewatch_options, "OptionsCheckButtonTemplate");
wgCB:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 210, -263);
wgCB:SetScript("OnClick", function(self) rewatch_ChangedDimentions = true; end);
-- text
local detail1 = rewatch_options:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
detail1:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -320); detail1:SetWidth(310); detail1:SetText(rewatch_loc["optiondetails"]);
-- dimentions
local slideHBHT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideHBHT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -30); slideHBHT:SetText("Healthbar height:");
local slideHBH = CreateFrame("SLIDER", "Rewatch_SlideHBH", rewatch_options2, "OptionsSliderTemplate");
slideHBH:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -30); slideHBH:SetMinMaxValues(5, 50); slideHBH:SetValueStep(1);
slideHBH:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideHBHText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideHBHLow"):SetText("5"); getglobal("Rewatch_SlideHBHHigh"):SetText("50");
local slideCBWT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideCBWT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -60); slideCBWT:SetText("Castbar width:");
local slideCBW = CreateFrame("SLIDER", "Rewatch_SlideCBW", rewatch_options2, "OptionsSliderTemplate");
slideCBW:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -60); slideCBW:SetMinMaxValues(50, 150); slideCBW:SetValueStep(1);
slideCBW:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideCBWText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideCBWLow"):SetText("50"); getglobal("Rewatch_SlideCBWHigh"):SetText("150");
local slideCBHT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideCBHT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -90); slideCBHT:SetText("Castbar height:");
local slideCBH = CreateFrame("SLIDER", "Rewatch_SlideCBH", rewatch_options2, "OptionsSliderTemplate");
slideCBH:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -90); slideCBH:SetMinMaxValues(5, 50); slideCBH:SetValueStep(1);
slideCBH:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideCBHText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideCBHLow"):SetText("5"); getglobal("Rewatch_SlideCBHHigh"):SetText("50");
local slideCBMT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideCBMT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -120); slideCBMT:SetText("Castbar margin:");
local slideCBM = CreateFrame("SLIDER", "Rewatch_SlideCBM", rewatch_options2, "OptionsSliderTemplate");
slideCBM:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -120); slideCBM:SetMinMaxValues(0, 10); slideCBW:SetValueStep(1);
slideCBM:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideCBMText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideCBMLow"):SetText("0"); getglobal("Rewatch_SlideCBMHigh"):SetText("10");
local slideBWT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideBWT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -150); slideBWT:SetText("Button width:");
local slideBW = CreateFrame("SLIDER", "Rewatch_SlideBW", rewatch_options2, "OptionsSliderTemplate");
slideBW:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -150); slideBW:SetMinMaxValues(10, 100); slideBW:SetValueStep(1);
slideBW:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideBWText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideBWLow"):SetText("10"); getglobal("Rewatch_SlideBWHigh"):SetText("100");
local slideBHT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideBHT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -180); slideBHT:SetText("Button height:");
local slideBH = CreateFrame("SLIDER", "Rewatch_SlideBH", rewatch_options2, "OptionsSliderTemplate");
slideBH:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -180); slideBH:SetMinMaxValues(10, 100); slideBH:SetValueStep(1);
slideBH:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideBHText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideBHLow"):SetText("10"); getglobal("Rewatch_SlideBHHigh"):SetText("100");
local slideBMT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideBMT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -210); slideBMT:SetText("Button margin:");
local slideBM = CreateFrame("SLIDER", "Rewatch_SlideBM", rewatch_options2, "OptionsSliderTemplate");
slideBM:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -210); slideBM:SetMinMaxValues(0, 10); slideBW:SetValueStep(1);
slideBM:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideBMText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideBMLow"):SetText("0"); getglobal("Rewatch_SlideBMHigh"):SetText("10");
local slideSBT = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
slideSBT:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -240); slideSBT:SetText("Sidebar (class) width:");
local slideSB = CreateFrame("SLIDER", "Rewatch_SlideSB", rewatch_options2, "OptionsSliderTemplate");
slideSB:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 213, -240); slideSB:SetMinMaxValues(0, 10); slideSB:SetValueStep(1);
slideSB:SetScript("OnValueChanged", function(self) rewatch_ChangedDimentions = true; getglobal("Rewatch_SlideSBText"):SetText(math.floor(self:GetValue()+0.5)); end);
getglobal("Rewatch_SlideSBLow"):SetText("0"); getglobal("Rewatch_SlideSBHigh"):SetText("10");
-- text
local detail2 = rewatch_options2:CreateFontString("$parentText", "ARTWORK", "GameFontHighlightSmall");
detail2:SetPoint("TOPLEFT", rewatch_options2, "TOPLEFT", 10, -270); detail2:SetWidth(310); detail2:SetText(rewatch_loc["optiondetails"]);
-- buttons
local buffCheckBTN = CreateFrame("BUTTON", "Rewatch_BuffCheckBTN", rewatch_options, "OptionsButtonTemplate"); buffCheckBTN:SetText(rewatch_loc["buffCheck"]);
buffCheckBTN:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 10, -350); buffCheckBTN:SetScript("OnClick", rewatch_BuffCheck); buffCheckBTN:SetWidth(115);
local sortBTN = CreateFrame("BUTTON", "Rewatch_BuffCheckBTN", rewatch_options, "OptionsButtonTemplate"); sortBTN:SetText(rewatch_loc["sortList"]); sortBTN:SetWidth(115);
sortBTN:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 125, -350); sortBTN:SetScript("OnClick", function() if(rewatch_loadInt["AutoGroup"] == 0) then rewatch_Message(rewatch_loc["nosort"]); else rewatch_Clear(); rewatch_changed = true; rewatch_Message(rewatch_loc["sorted"]); end; end);
local clearBTN = CreateFrame("BUTTON", "Rewatch_BuffCheckBTN", rewatch_options, "OptionsButtonTemplate"); clearBTN:SetText(rewatch_loc["clearList"]); clearBTN:SetWidth(115);
clearBTN:SetPoint("TOPLEFT", rewatch_options, "TOPLEFT", 240, -350); clearBTN:SetScript("OnClick", function() rewatch_Clear(); rewatch_Message(rewatch_loc["cleared"]); end);
-- handlers
rewatch_options.okay = function(self) rewatch_OptionsFromData(false); if(rewatch_ChangedDimentions) then rewatch_Clear(); rewatch_changed = true; rewatch_Message(rewatch_loc["sorted"]); rewatch_ChangedDimentions = false; end; end;
rewatch_options.cancel = function(self) rewatch_OptionsFromData(true); end;
rewatch_options.default = function(self)
	rewatch_load["GcdAlpha"], rewatch_load["HideSolo"], rewatch_load["Hide"], rewatch_load["AutoGroup"], rewatch_load["NaturesSplendor"], rewatch_load["GoLB"], rewatch_load["GoSM"], rewatch_load["T5"] = 1, 0, 0, 1, 0, 0, 0, 0;
	rewatch_loadInt["GcdAlpha"], rewatch_loadInt["HideSolo"], rewatch_loadInt["Hide"], rewatch_loadInt["AutoGroup"], rewatch_loadInt["NaturesSplendor"], rewatch_loadInt["GoLB"], rewatch_loadInt["GoSM"], rewatch_loadInt["T5"] = 1, 0, 0, 1, 0, 0, 0, 0;
	rewatch_loadInt["Lock"] = false; rewatch_loadInt["WildGrowth"] = 1; rewatch_load["WildGrowth"] = 1;
	rewatch_OptionsFromData(true);
end;
InterfaceOptions_AddCategory(rewatch_options); InterfaceOptions_AddCategory(rewatch_options2);

-- make a tooltip object
rewatch_tooltip = CreateFrame("GameTooltip", "rewatch_tooltip", WorldFrame, "GameTooltipTemplate");
rewatch_tooltip:SetOwner(WorldFrame, "ANCHOR_NONE");
rewatch_tooltip:AddFontStrings(
    rewatch_tooltip:CreateFontString("$parentTextLeft1", nil, "GameTooltipText"),
	rewatch_tooltip:CreateFontString("$parentTextRight1", nil, "GameTooltipText")
);

-- make sure we catch events and process them
local status, playerId, r, g, b, a, val, left, i, debuffType;
rewatch_events:SetScript("OnEvent", function(timestamp, event, ...)
	-- only process if properly loaded
	if(not rewatch_loadInt["Loaded"]) then return; end;
	-- if the group/raid the player is in has changed
	if(event == "PARTY_MEMBERS_CHANGED") then		
		rewatch_changed = true;
	-- update mana/energy/rage bar color
	elseif(event == "UPDATE_SHAPESHIFT_FORM") then
		for i=1,rewatch_i-1 do val = rewatch_bars[i]; if(val) then
			a = UnitPowerType(val["Player"]);
			if(a == 0) then val["ManaBar"]:SetStatusBarColor(0.0, 0.0, 0.6, 0.8);
			elseif(a == 1) then val["ManaBar"]:SetStatusBarColor(0.6, 0.0, 0.0, 0.8);
			elseif(a == 6) then val["ManaBar"]:SetStatusBarColor(0.85, 0.15, 0.8, 0.8);
			else val["ManaBar"]:SetStatusBarColor(0.95, 0.85, 0.15, 0.8); end;
		end; end;
	-- update threat
	elseif(event == "UNIT_THREAT_SITUATION_UPDATE") then
		if(arg1) then
			playerId = rewatch_GetPlayer(UnitName(arg1));
			if(playerId >= 0) then
				val = rewatch_bars[playerId];
				if(val["UnitGUID"]) then
					status = UnitThreatSituation(val["Player"]);
					if(status == 0) then val["PlayerBar"].text:SetTextColor(1, 1, 1, 1);
					else r, g, b = GetThreatStatusColor(status); val["PlayerBar"].text:SetTextColor(r, g, b, 1); end;
				end;
			end;
		end;
	-- so first of all, check spell_aura_applied for the wild growth buff
	elseif((arg2 == "SPELL_AURA_APPLIED_DOSE") or (arg2 == "SPELL_AURA_APPLIED") or (arg2 == "SPELL_AURA_REFRESH")) then
		--  ignore heals on non-party-/raidmembers
		if(not rewatch_InGroup(arg7)) then return; end;
		-- if it was a wild growth
		if(((arg3 == UnitGUID("player")) or (arg2 == "SPELL_AURA_REFRESH")) and (arg10 == rewatch_loc["wildgrowth"]) and (rewatch_loadInt["WildGrowth"] == 1)) then
			-- get the player position, or if -1, return
			playerId = rewatch_GetPlayer(arg7);
			if(playerId < 0) then return; end;
			-- update the spellbar
			rewatch_UpdateBar(arg10, playerId);
		-- else, if it was a debuff applied
		elseif(arg12 == "DEBUFF") then
			-- get the player position, or if -1, return
			playerId = rewatch_GetPlayer(arg7);
			if(playerId < 0) then return; end;
			-- get the debuff type
			_, _, _, _, debuffType = UnitDebuff(arg7, arg10);
			-- process it
			if(debuffType == "Curse") then
				rewatch_bars[playerId]["Curse"] = arg10;
			elseif(debuffType == "Poison") then
				rewatch_bars[playerId]["Poison"] = arg10;
			end;
		end;
	-- if an aura faded
	elseif((arg2 == "SPELL_AURA_REMOVED") or (arg2 == "SPELL_AURA_DISPELLED") or (arg2 == "SPELL_AURA_REMOVED_DOSE")) then
		--  ignore non-party-/raidmembers
		if(not rewatch_InGroup(arg7)) then return; end;
		-- get the player position, or if -1, return
		playerId = rewatch_GetPlayer(arg7);
		if(playerId < 0) then return; end;
		-- process it if it is the applied curse or poison
		if(rewatch_bars[playerId]["Curse"] == arg10) then
			rewatch_bars[playerId]["Curse"] = nil;
		elseif(rewatch_bars[playerId]["Poison"] == arg10) then
			rewatch_bars[playerId]["Poison"] = nil;
		-- or, if a HoT has been dispelled, also process it
		elseif(arg4 == UnitName("player")) then rewatch_DowndateBar(arg10, playerId);
		end;
	-- if an other spell was cast successfull by the user or a heal has been received
	elseif((arg2 == "SPELL_CAST_SUCCESS") or (arg2 == "SPELL_HEAL")) then
		-- if it was your spell/heal
		if(arg3 == UnitGUID("player")) then
			rewatch_TriggerCooldown();
			if((arg10 == rewatch_loc["regrowth"]) or (arg10 == rewatch_loc["rejuvenation"]) or ((arg10 == rewatch_loc["lifebloom"]) and (arg2 == "SPELL_CAST_SUCCESS"))) then
				--  ignore heals on non-party-/raidmembers
				if(not rewatch_InGroup(arg7)) then return; end;
				-- get the player position, or if -1, create a new frame
				playerId = rewatch_GetPlayer(arg7);
				if(playerId < 0) then
					if(rewatch_loadInt["AutoGroup"] == 0) then return;
					else playerId = rewatch_AddPlayer(UnitName(arg7)); end;
				end;
				-- update the spellbar
				rewatch_UpdateBar(arg10, playerId);
			-- if a swiftmend was received
			elseif((arg10 == rewatch_loc["swiftmend"]) and (arg2 == "SPELL_HEAL")) then
				--  ignore heals on non-party-/raidmembers
				if(not rewatch_InGroup(arg7)) then return; end;
				-- get the player position, return if -1
				playerId = rewatch_GetPlayer(UnitName(arg7));
				if(playerId < 0) then return;
				else rewatch_ProcessSwiftmend(playerId); end;
			end;
		end;
	end;
	
	-- return
	return;
end);

-- update everything
rewatch_events:SetScript("OnUpdate", function()
	-- load saved vars
	if(not rewatch_loadInt["Loaded"]) then rewatch_OnLoad();
	else
		-- if the group formation has been changed, add new group members to the list
		if(rewatch_changed) then if(rewatch_loadInt["AutoGroup"] == 1) then
			if(InCombatLockdown() ~= 1) then
				if((GetNumRaidMembers() == 0) and (GetNumPartyMembers() == 0)) then rewatch_Clear(); end;
				if(rewatch_i == 1) then rewatch_AddPlayer(UnitName("player")); end;
				rewatch_ProcessGroup(); rewatch_changed = nil;
			end;
		end; end;
		-- process updates
		for i=1,rewatch_i-1 do val = rewatch_bars[i]; if(val) then
			-- clear buffs if the player just died
			if((UnitIsDeadOrGhost(val["Player"])) and (select(4, val["PlayerBar"]:GetStatusBarColor()) > 0.6)) then
				val["PlayerBar"]:SetStatusBarColor(0.5, 0.5, 0.5, 0.5);
				val["PlayerBar"].text:SetTextColor(1, 1, 1, 1); val["ManaBar"]:SetValue(0); val["PlayerBar"]:SetValue(0);
				val["Frame"]:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a);
				val["LifebloomStacks"] = 0; val["PlayerBar"].text:SetText(val["Player"]);
				if(rewatch_loadInt["Labels"] == 0) then
					val[rewatch_loc["rejuvenation"].."Bar"].text:SetText("");
					val[rewatch_loc["regrowth"].."Bar"].text:SetText("");
					val[rewatch_loc["lifebloom"].."Bar"].text:SetText("");
					val[rewatch_loc["wildgrowth"].."Bar"].text:SetText("");
				end;
				val[rewatch_loc["rejuvenation"]] = 0; val[rewatch_loc["rejuvenation"].."Bar"]:SetValue(0);
				val[rewatch_loc["regrowth"]] = 0; val[rewatch_loc["regrowth"].."Bar"]:SetValue(0);
				val[rewatch_loc["lifebloom"]] = 0; val[rewatch_loc["lifebloom"].."Bar"]:SetValue(0);
				if(val[rewatch_loc["wildgrowth"].."Bar"]) then
					val[rewatch_loc["wildgrowth"]] = 0; val[rewatch_loc["wildgrowth"].."Bar"]:SetValue(0);
				end;
				val["Poison"] = nil; val["Curse"] = nil; val["Frame"]:SetAlpha(0.2);
			elseif(UnitIsDeadOrGhost(val["Player"])) then
				-- player's dead and processed that, ignore it now
			else
				-- get and set health data
				a, b = UnitHealthMax(val["Player"]), UnitHealth(val["Player"]);
				val["PlayerBar"]:SetMinMaxValues(0, a); val["PlayerBar"]:SetValue(b);
				-- set healthbar color accordingly
				r = 0; if(a == b) then val["PlayerBar"]:SetStatusBarColor(0.0, 0.85, 0.0, 0.9);
				elseif(b/a < .25) then r = 1; val["PlayerBar"]:SetStatusBarColor(0.6, 0.0, 0.0, 0.9);
				elseif(b/a < .50) then val["PlayerBar"]:SetStatusBarColor(0.6, 0.6, 0.0, 0.9);
				else val["PlayerBar"]:SetStatusBarColor(0.0, 0.6, 0.0, 0.8); end;
				-- update text if needed
				if(val["Hover"] == 1) then val["PlayerBar"].text:SetText(string.format("%i/%i", b, a));
				elseif(val["Hover"] == 2) then val["PlayerBar"].text:SetText(val["Player"]); val["Hover"] = 0; end;
				-- get and set mana data
				a, b = UnitManaMax(val["Player"]), UnitMana(val["Player"]);
				val["ManaBar"]:SetMinMaxValues(0, a); val["ManaBar"]:SetValue(b);
				-- poison/curse checks
				if(rewatch_IsPoisoned(i)) then r = 1; val["AbolishPoisonButton"]:SetAlpha(1); else val["AbolishPoisonButton"]:SetAlpha(0.15); end;
				if(rewatch_IsCursed(i)) then r = 1; val["DecurseButton"]:SetAlpha(1); else val["DecurseButton"]:SetAlpha(0.15); end;
				-- color entire frame when attention is required
				if(r > 0) then val["Frame"]:SetBackdropColor(0.7, 0, 0, 0.5);
				else val["Frame"]:SetBackdropColor(rewatch_loadInt["FrameColor"].r, rewatch_loadInt["FrameColor"].g, rewatch_loadInt["FrameColor"].b, rewatch_loadInt["FrameColor"].a); end;
				-- fade when out of range
				if(IsSpellInRange(rewatch_loc["rejuvenation"], val["Player"]) == 1) then val["Frame"]:SetAlpha(1); else val["Frame"]:SetAlpha(0.3); end;
				-- rejuvenation bar process
				if(val[rewatch_loc["rejuvenation"]] <= 0) then -- nuffin!
				elseif(GetTime() >= val[rewatch_loc["rejuvenation"]]) then
					val[rewatch_loc["rejuvenation"].."Bar"]:SetValue(0); val[rewatch_loc["rejuvenation"]] = 0;
					if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["rejuvenation"].."Bar"].text:SetText(""); end;
				else
					left = val[rewatch_loc["rejuvenation"]]-GetTime();
					val[rewatch_loc["rejuvenation"].."Bar"]:SetValue(left);
					if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["rejuvenation"].."Bar"].text:SetText(string.format("%.0f", left)); end;
					if(math.abs(left-2)<0.1) then val[rewatch_loc["rejuvenation"].."Bar"]:SetStatusBarColor(0.6, 0.0, 0.0, 0.8); end;
				end;
				-- regrowth bar process
				if(val[rewatch_loc["regrowth"]] <= 0) then --nuffin!
				elseif(GetTime() >= val[rewatch_loc["regrowth"]]) then
					val[rewatch_loc["regrowth"].."Bar"]:SetValue(0); val[rewatch_loc["regrowth"]] = 0;
					if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["regrowth"].."Bar"].text:SetText(""); end;
				else
					left = val[rewatch_loc["regrowth"]]-GetTime();
					val[rewatch_loc["regrowth"].."Bar"]:SetValue(left);
					if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["regrowth"].."Bar"].text:SetText(string.format("%.0f", left)); end;
					if(math.abs(left-2)<0.1) then val[rewatch_loc["regrowth"].."Bar"]:SetStatusBarColor(0.6, 0.0, 0.0, 0.8); end;
				end;
				-- lifebloom bar process
				if(val[rewatch_loc["lifebloom"]] <= 0) then --nuffin!
				elseif(GetTime() >= val[rewatch_loc["lifebloom"]]) then
					val[rewatch_loc["lifebloom"].."Bar"]:SetValue(0); val[rewatch_loc["lifebloom"]] = 0; val["LifebloomStacks"] = 0;
					if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["lifebloom"].."Bar"].text:SetText(""); end;
				else
					left = val[rewatch_loc["lifebloom"]]-GetTime(); val[rewatch_loc["lifebloom"].."Bar"]:SetValue(left);
					if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["lifebloom"].."Bar"].text:SetText(string.format("%.0f", left)); end;
					-- check if lifebloom stack counter is valid
					r = nil; if(left>(rewatch_abs[rewatch_loc["lifebloom"]].Duration-0.5)) then
						-- get the actual stacked amount
						for a=1,40 do
							playerId, _, _, b, debuffType = UnitBuff(val["Player"], a, 1); -- playerId = name and debuffType = duration, just reusing vars
							if(not playerId) then break; elseif((playerId == rewatch_loc["lifebloom"]) and (debuffType)) then if(val["LifebloomStacks"] ~= b) then r = b; val["LifebloomStacks"] = b; end; break; end;
						end;
						-- if a change occurred, process
						if(r) then
							-- apply change to scaling and text
							if(val["LifebloomStacks"] > 0) then
								if(r == 1) then r = ""; end;
								val[rewatch_loc["lifebloom"].."Bar"]:SetStatusBarColor(rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]..r].r, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]..r].g, rewatch_loadInt["BarColor"..rewatch_loc["lifebloom"]..r].b, 0.8);
							-- force reset if there wuz none
							else val[rewatch_loc["lifebloom"]] = 1; end;
						end;
					end;
					if(math.abs(left-2)<0.1) then val[rewatch_loc["lifebloom"].."Bar"]:SetStatusBarColor(0.6, 0.0, 0.0, 0.8); end;
				end;
				-- wild growth bar process
				if(val[rewatch_loc["wildgrowth"].."Bar"]) then
					if(val[rewatch_loc["wildgrowth"]] <= 0) then -- nuffin!
					elseif(GetTime() >= val[rewatch_loc["wildgrowth"]]) then
						val[rewatch_loc["wildgrowth"].."Bar"]:SetValue(0); val[rewatch_loc["wildgrowth"]] = 0;
						if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["wildgrowth"].."Bar"].text:SetText(""); end;
					else
						left = val[rewatch_loc["wildgrowth"]]-GetTime();
						val[rewatch_loc["wildgrowth"].."Bar"]:SetValue(left);
						if(rewatch_loadInt["Labels"] == 0) then val[rewatch_loc["wildgrowth"].."Bar"].text:SetText(string.format("%.0f", left)); end;
						if(math.abs(left-2)<0.1) then val[rewatch_loc["wildgrowth"].."Bar"]:SetStatusBarColor(0.6, 0.0, 0.0, 0.8); end;
					end;
				end;
			end;
		end; end;
	end;
	
	-- return
	return;
end);